Package: SCArray
Type: Package
Title: Large-scale single-cell omics data manipulation with GDS files
Version: 1.19.0
Date: 2024-03-24
Depends: R (>= 3.5.0), gdsfmt (>= 1.36.0), methods, DelayedArray (>=
        0.31.5)
Imports: S4Vectors, utils, Matrix, SparseArray (>= 1.5.13),
        BiocParallel, DelayedMatrixStats, SummarizedExperiment,
        SingleCellExperiment, BiocSingular
Suggests: BiocGenerics, scater, scuttle, uwot, RUnit, knitr, markdown,
        rmarkdown, rhdf5, HDF5Array
Authors@R: c(person("Xiuwen", "Zheng", role=c("aut", "cre"),
        email="xiuwen.zheng@abbvie.com",
        comment=c(ORCID="0000-0002-1390-0708")))
Description: Provides large-scale single-cell omics data manipulation using
        Genomic Data Structure (GDS) files. It combines dense and sparse
        matrices stored in GDS files and the Bioconductor infrastructure
        framework (SingleCellExperiment and DelayedArray) to provide
        out-of-memory data storage and large-scale manipulation using the R
        programming language.
License: GPL-3
VignetteBuilder: knitr
ByteCompile: TRUE
URL: https://github.com/AbbVie-ComputationalGenomics/SCArray
biocViews: Infrastructure, DataRepresentation, DataImport, SingleCell,
        RNASeq
git_url: https://git.bioconductor.org/packages/SCArray
git_branch: devel
git_last_commit: d488bb9
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-03
NeedsCompilation: yes
Packaged: 2025-11-04 00:40:58 UTC; biocbuild
Author: Xiuwen Zheng [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1390-0708>)
Maintainer: Xiuwen Zheng <xiuwen.zheng@abbvie.com>

# Native routines that are to be used in R via .Call
useDynLib(SCArray,
    c_add, c_get_split,
    c_rowSums, c_colSums, c_rowProds, c_colProds,
    c_rowMeans, c_rowMeans_final, c_colMeans,
    c_rowWMeans, c_rowWMeans_final, c_colWMeans,
    c_rowVars, c_rowVars_final, c_colVars,
    c_rowWVars, c_rowWVars_final, c_colWVars,
    c_rowMeanVar_final, c_colMeanVar,
    c_rowMins, c_colMins, c_rowMaxs, c_colMaxs, c_rowRanges, c_colRanges,
    c_row_sum_grp, c_col_sum_grp, c_row_nnzero, c_col_nnzero,
    c_row_anyNA, c_col_anyNA,
    c_rowCollapse_init, c_rowCollapse_done, c_rowCollapse,
    c_colCollapse_init, c_colCollapse,
    c_sparse_blocksize)

# Export the following names
exportPattern("^sc*")
exportClasses(SCArrayFileClass, SC_GDSArray, SC_GDSMatrix)
exportMethods(
    rowSums, colSums, rowSums2, colSums2, rowProds, colProds,
    rowLogSumExps, colLogSumExps,
    rowMeans, colMeans, rowMeans2, colMeans2,
    rowWeightedMeans, colWeightedMeans,
    rowVars, colVars, rowSds, colSds,
    rowWeightedVars, colWeightedVars, rowWeightedSds, colWeightedSds,
    rowMins, colMins, rowMaxs, colMaxs, rowRanges, colRanges,
    rowAnyNAs, colAnyNAs, rowCollapse, colCollapse,
    rowDiffs, colDiffs, rowSdDiffs, colSdDiffs, rowVarDiffs, colVarDiffs,
    rowAvgsPerColSet, colAvgsPerRowSet,
    row_nnzero, col_nnzero,
    colsum, rowsum, scale, pmin2, pmax2,
    runPCA
)


# Import all packages listed as Imports or Depends
import(methods)
import(gdsfmt)
import(SparseArray)
import(DelayedArray)
import(DelayedMatrixStats)
importFrom(utils, head, object.size, packageVersion, read.delim, str,
    txtProgressBar, setTxtProgressBar)
importFrom(Matrix, crossprod, tcrossprod, nnzero, readMM)
importFrom(S4Vectors, DataFrame, metadata, new2)
importFrom(BiocSingular, bsparam, runPCA)
importFrom(BiocParallel,
    bplapply, bpnworkers, bpstart, bpstop, bpisup, SerialParam)
importFrom(SummarizedExperiment, SummarizedExperiment, colData, rowData,
    assays, "assays<-", assay, "assay<-")
importFrom(SingleCellExperiment, SingleCellExperiment, altExp,
    reducedDim, "reducedDim<-")

Large-scale single-cell omics data manipulation using GDS files
====

![GPLv3](http://www.gnu.org/graphics/gplv3-88x31.png)
[GNU General Public License, GPLv3](http://www.gnu.org/copyleft/gpl.html)


## Features

SCArray provides large-scale single-cell omics data manipulation using Genomic Data Structure (GDS) files. It combines dense and sparse matrices stored in GDS files and the Bioconductor infrastructure framework (SingleCellExperiment and DelayedArray) to provide out-of-memory data storage and large-scale manipulation using the R programming language.


## Bioconductor

v1.12.0 ([http://bioconductor.org/packages/SCArray/](http://bioconductor.org/packages/SCArray/))

Package News: [NEWS](./NEWS)


## Package Maintainer

[Xiuwen Zheng](xiuwen.zheng@abbvie.com)


## Installation

* Requires R (≥ v3.5.0), [gdsfmt](http://www.bioconductor.org/packages/gdsfmt) (≥ v1.36.0)

* Bioconductor repository
```R
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("SCArray")
```


## Examples

```R
suppressPackageStartupMessages(library(SCArray))

# the GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")
sce <- scExperiment(fn)

sce
## class: SingleCellExperiment
## dim: 1000 850
## metadata(0):
## assays(1): counts
## rownames(1000): MRPL20 GNB1 ... RPS4Y1 CD24
## rowData names(0):
## colnames(850): 1772122_301_C02 1772122_180_E05 ... 1772122_180_B06 1772122_180_D09
## colData names(3): Cell_ID Cell_type Timepoint
## reducedDimNames(0):
## mainExpName: NULL
## altExpNames(0):

counts(sce)
## <1000 x 850> sparse matrix of class SC_GDSMatrix and type "double":
##              1772122_301_C02 1772122_180_E05 1772122_300_H02 ... 1772122_180_B06
##       MRPL20               3               2               3   .               0
##         GNB1              11               6              15   .               0
##        RPL22               3               5               7   .               6
##        PARK7               1               7               3   .               2
##         ENO1               8              19              20   .               7
##          ...               .               .               .   .               .
##         SSR4               0               6               3   .               5
##        RPL10              11               4               8   .               1
## SLC25A6_loc1               4               5               5   .               3
##       RPS4Y1               0               5               0   .               2
##         CD24              18               3               7   .               0
```


## Optimized implementation of GDS-based DelayedMatrix

- ✓ = Implemented in **SCArray** for `SC_GDSMatrix`
- ⦿ = Implemented in [**DelayedMatrixStats**](http://bioconductor.org/packages/DelayedMatrixStats/) or [**MatrixGenerics**](http://bioconductor.org/packages/MatrixGenerics/)

| Method                 | Optimized | Notes                    |
|:-----------------------|:---------:|:-------------------------|
| `colAlls()`            | ⦿         |                  |
| `colAnyNAs()`          | ✓         | Check if any NA in a column  |
| `colAnys()`            | ⦿         |                  |
| `colAvgsPerRowSet()`   | ✓         | Summary statistic for equally sized subsets of rows  |
| `colCollapse()`        | ✓         | Extract one cell from each column  |
| `colCounts()`          | ⦿         |                  |
| `colCummaxs()`         | ⦿         |                  |
| `colCummins()`         | ⦿         |                  |
| `colCumprods()`        | ⦿         |                  |
| `colCumsums()`         | ⦿         |                  |
| `colDiffs()`           | ✓         | Difference between each element of a column  |
| `colIQRDiffs()`        | ⦿         |                  |
| `colIQRs()`            | ⦿         |                  |
| `colLogSumExps()`      | ✓         | Log of the sum of exponentials for each column  |
| `colMadDiffs()`        | ⦿         |                  |
| `colMads()`            | ⦿         |                  |
| `colMaxs()`            | ✓         | Maximum for each column  |
| `colMeans()`           | ✓         | Mean for each column  |
| `colMeans2()`          | ✓         | Mean for each column  |
| `colMedians()`         | ⦿         |                  |
| `colMins()`            | ✓         | Minimum for each column  |
| `colOrderStats()`      | ⦿         |                  |
| `colProds()`           | ✓         | Product for each column  |
| `colQuantiles()`       | ⦿         |                  |
| `colRanges()`          | ✓         | Minimum and maximum for each column  |
| `colRanks()`           | ⦿         |                  |
| `colSdDiffs()`         | ✓         | Standard deviation of the difference between each element of a column  |
| `colSds()`             | ✓         | Standard deviation for each column  |
| `colsum()`             | ✓         | Row sums across columns  |
| `colSums()`            | ✓         | Sum for each column  |
| `colSums2()`           | ✓         | Sum for each column  |
| `colTabulates()`       | ⦿         |                  |
| `colVarDiffs()`        | ✓         | Variance of the difference between each element of a column  |
| `colVars()`            | ✓         | Variance for each column  |
| `colWeightedMads()`    | ⦿         |                  |
| `colWeightedMeans()`   | ✓         | Weighted mean for each column  |
| `colWeightedMedians()` | ⦿         |                  |
| `colWeightedSds()`     | ✓         | Weighted standard deviation for each column  |
| `colWeightedVars()`    | ✓         | Weighted variance for each column  |
| `rowAlls()`            | ⦿         |                  |
| `rowAnyNAs()`          | ✓         | Check if any NA in a row  |
| `rowAnys()`            | ⦿         |                  |
| `rowAvgsPerColSet()`   | ✓         | Summary statistic for equally sized subsets of columns  |
| `rowCollapse()`        | ✓         | Extract one cell from each row  |
| `rowCounts()`          | ⦿         |                  |
| `rowCummaxs()`         | ⦿         |                  |
| `rowCummins()`         | ⦿         |                  |
| `rowCumprods()`        | ⦿         |                  |
| `rowCumsums()`         | ⦿         |                  |
| `rowDiffs()`           | ✓         | Difference between each element of a row  |
| `rowIQRDiffs()`        | ⦿         |                  |
| `rowIQRs()`            | ⦿         |                  |
| `rowLogSumExps()`      | ✓         | Log of the sum of exponentials for each row  |
| `rowMadDiffs()`        | ⦿         |                  |
| `rowMads()`            | ⦿         |                  |
| `rowMaxs()`            | ✓         | Maximum for each row  |
| `rowMeans()`           | ✓         | Mean for each row  |
| `rowMeans2()`          | ✓         | Mean for each row  |
| `rowMedians()`         | ⦿         |                  |
| `rowMins()`            | ✓         | Minimum for each row  |
| `rowOrderStats()`      | ⦿         |                  |
| `rowProds()`           | ✓         | Product for each row  |
| `rowQuantiles()`       | ✓         |                  |
| `rowRanges()`          | ✓         | Minimum and maximum for each column  |
| `rowRanks()`           | ⦿         |                  |
| `rowSdDiffs()`         | ✓         | Standard deviation of the difference between each element of a row  |
| `rowSds()`             | ✓         | Standard deviation for each row  |
| `rowsum()`             | ✓         | Column sums across rows  |
| `rowSums()`            | ✓         | Sum for each row  |
| `rowSums2()`           | ✓         | Sum for each row  |
| `rowTabulates()`       | ⦿         |                  |
| `rowVarDiffs()`        | ✓         | Variance of the difference between each element of a row  |
| `rowVars()`            | ✓         | Variance for each row  |
| `rowWeightedMads()`    | ⦿         |                  |
| `rowWeightedMeans()`   | ✓         | Weighted mean for each row  |
| `rowWeightedMedians()` | ⦿         |                  |
| `rowWeightedSds()`     | ✓         | Weighted standard deviation for each row  |
| `rowWeightedVars()`    | ✓         | Weighted variance for each row |

#######################################################################
#
# Package name: SCArray
#
# Description:
#     Large-scale single-cell RNA-seq data manipulation with GDS files
#
# Copyright (C) 2023    Xiuwen Zheng (@AbbVie-ComputationalGenomics)
# License: GPL-3
#


#######################################################################
# Generic functions -- scColMeanVar(), scRowMeanVar()

x_num_row_mean_var <- function(x, na.rm=FALSE, useNames=FALSE, ...)
{
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    v <- cbind(rowMeans(x, na.rm=na.rm), rowVars(x, na.rm=na.rm))
    colnames(v) <- c("mean", "var")
    if (isTRUE(useNames)) rownames(v) <- rownames(x)
    v
}

x_num_col_mean_var <- function(x, na.rm=FALSE, useNames=FALSE, ...)
{
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    v <- cbind(colMeans(x, na.rm=na.rm), colVars(x, na.rm=na.rm))
    colnames(v) <- c("mean", "var")
    if (isTRUE(useNames)) rownames(v) <- colnames(x)
    v
}

.x_row_mean_var <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    # block read
    lst <- .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowVars, bk, v, na.rm, NULL)
        },
        InitFun = .double_nrow3,
        ReduceFun=`+`, na.rm=na.rm)
    # finally
    .Call(c_rowMeanVar_final, lst)
}

.x_col_mean_var <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    # block read
    lst <- .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colMeanVar, bk, na.rm)
        },
        .flatten=FALSE, na.rm=na.rm)
    # finally
    do.call(rbind, lst)
}

x_sc_row_mean_var <- function(x, na.rm=FALSE, useNames=FALSE, ...)
{
    stopifnot(is(x, "SC_GDSMatrix"))
    x_check(x, "Calling SCArray::scRowMeanVar() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k == 1L)
    {
        v <- .x_row_mean_var(x, na.rm, ...)
    } else if (k == 2L)
    {
        v <- .x_col_mean_var(t(x), na.rm, ...)
    } else {
        v <- cbind(rowMeans(x, na.rm=na.rm), rowVars(x, na.rm=na.rm))
    }
    colnames(v) <- c("mean", "var")
    if (isTRUE(useNames)) rownames(v) <- rownames(x)
    v
}

x_sc_col_mean_var <- function(x, na.rm=FALSE, useNames=FALSE, ...)
{
    stopifnot(is(x, "SC_GDSMatrix"))
    x_check(x, "Calling SCArray::scColMeanVar() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k == 1L)
    {
        v <- .x_col_mean_var(x, na.rm, ...)
    } else if (k == 2L)
    {
        v <- .x_row_mean_var(t(x), na.rm, ...)
    } else {
        v <- cbind(colMeans(x, na.rm=na.rm), colVars(x, na.rm=na.rm))
    }
    colnames(v) <- c("mean", "var")
    if (isTRUE(useNames)) rownames(v) <- colnames(x)
    v
}


setGeneric("scRowMeanVar", function(x, na.rm=FALSE, useNames=FALSE, ...)
    standardGeneric("scRowMeanVar"))
setGeneric("scColMeanVar", function(x, na.rm=FALSE, useNames=FALSE, ...)
    standardGeneric("scColMeanVar"))

setMethod("scRowMeanVar", "matrix", x_num_row_mean_var)
setMethod("scColMeanVar", "matrix", x_num_col_mean_var)

setMethod("scRowMeanVar", "Matrix", x_num_row_mean_var)
setMethod("scColMeanVar", "Matrix", x_num_col_mean_var)

setMethod("scRowMeanVar", SMatrix, x_sc_row_mean_var)
setMethod("scColMeanVar", SMatrix, x_sc_col_mean_var)


#######################################################################

x_num_row_nnzero <- function(x, na.counted=NA, ...)
{
    stopifnot(is.logical(na.counted), length(na.counted)==1L)
    x <- x != 0L
    if (isTRUE(na.counted))
    {
        rowSums(x, na.rm=TRUE) + rowSums(is.na(x))
    } else if (isFALSE(na.counted))
    {
        rowSums(x, na.rm=TRUE)
    } else {
        rowSums(x)
    }
}

x_num_col_nnzero <- function(x, na.counted=NA, ...)
{
    stopifnot(is.logical(na.counted), length(na.counted)==1L)
    x <- x != 0L
    if (isTRUE(na.counted))
    {
        colSums(x, na.rm=TRUE) + colSums(is.na(x))
    } else if (isFALSE(na.counted))
    {
        colSums(x, na.rm=TRUE)
    } else {
        colSums(x)
    }
}


.x_row_nnzero <- function(x, na.counted=NA, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_row_nnzero, bk, v, na)
        },
        InitFun = function(x, ...) integer(nrow(x)),
        ReduceFun=`+`, na=na.counted)
}

.x_col_nnzero <- function(x, na.counted=NA, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_col_nnzero, bk, na)
        },
        na=na.counted)
}

x_sc_row_nnzero <- function(x, na.counted=NA, ...)
{
    stopifnot(is(x, "SC_GDSMatrix"))
    x_check(x, "Calling SCArray::row_nnzero() with %s ...")
    stopifnot(is.logical(na.counted), length(na.counted)==1L)
    if (x_type(x) == 2L)
    {
        .x_col_nnzero(t(x), na.counted, ...)
    } else {
        .x_row_nnzero(x, na.counted, ...)
    }
}

x_sc_col_nnzero <- function(x, na.counted=NA, ...)
{
    stopifnot(is(x, "SC_GDSMatrix"))
    x_check(x, "Calling SCArray::col_nnzero() with %s ...")
    stopifnot(is.logical(na.counted), length(na.counted)==1L)
    if (x_type(x) == 2L)
    {
        .x_row_nnzero(t(x), na.counted, ...)
    } else {
        .x_col_nnzero(x, na.counted, ...)
    }
}


setGeneric("row_nnzero",
    function(x, na.counted=NA, ...) standardGeneric("row_nnzero"))
setGeneric("col_nnzero",
    function(x, na.counted=NA, ...) standardGeneric("col_nnzero"))

setMethod("row_nnzero", "matrix", x_num_row_nnzero)
setMethod("col_nnzero", "matrix", x_num_col_nnzero)

setMethod("row_nnzero", "Matrix", x_num_row_nnzero)
setMethod("col_nnzero", "Matrix", x_num_col_nnzero)

setMethod("row_nnzero", "DelayedMatrix", x_num_row_nnzero)
setMethod("col_nnzero", "DelayedMatrix", x_num_col_nnzero)

setMethod("row_nnzero", SMatrix, x_sc_row_nnzero)
setMethod("col_nnzero", SMatrix, x_sc_col_nnzero)



#######################################################################

x_runPCA <- function(x, rank=64, center=TRUE, scale=FALSE, get.rotation=TRUE,
    get.pcs=TRUE, ...)
{
    x_check(x, "Calling SCArray:::x_runPCA() with %s ...")
    # centering and scaling by myself
    if (isTRUE(center) || isTRUE(scale))
        x <- x_scale_col(x, center=center, scale=scale, with_attr=FALSE)
    # output
    callNextMethod(x=x, rank=rank, center=FALSE, scale=FALSE,
        get.rotation=get.rotation, get.pcs=get.pcs, ...)
}

setMethod("runPCA", SMatrix, x_runPCA)


#######################################################################

x_runsvd <- function(x, rank, scale=FALSE, approx=TRUE)
{
    # to use crossprod
    if (x_verbose())
        .cat("Using cross product for PCA")
    # call centering and scaling
    x <- x_scale_col(x, center=TRUE, scale=scale, with_attr=FALSE)
    # fold = 1 for using cross product
    if (approx)
    {
        rv <- BiocSingular::runIrlbaSVD(x, k=rank, nu=rank, nv=rank,
            center=FALSE, scale=scale, deferred=FALSE, fold=1)
    } else {
        rv <- BiocSingular::runExactSVD(x, k=rank, nu=rank, nv=rank,
            center=FALSE, scale=scale, deferred=FALSE, fold=1)
    }
    # output
    out <- list(sdev = rv$d/sqrt(nrow(x) - 1))
    out$rotation <- rv$v
    colnames(out$rotation) <- sprintf("PC%i", seq_len(ncol(out$rotation)))
    out$x <- sweep(rv$u, 2, rv$d, "*")
    colnames(out$x) <- sprintf("PC%i", seq_len(ncol(out$x)))
    out
}


scRunPCA <- function(sce, ncomponents=50, ntop=500, subset_row=NULL,
    scale=FALSE, altexp=NULL, name="PCA", exprs_values="logcounts", dimred=NULL,
    n_dimred=NULL, BSPARAM=NULL, BPPARAM=SerialParam(), verbose=TRUE)
{
    # check
    stopifnot(is(sce, "SingleCellExperiment") || is(sce, "SummarizedExperiment"))
    stopifnot(is.numeric(ncomponents), length(ncomponents)==1L)

    # get the working matrix 'mat'
    y <- sce
    if (!is.null(altexp)) y <- altExp(sce, altexp)
    transposed <- !is.null(dimred)
    if (!is.null(dimred))
    {
        mat <- reducedDim(y, dimred)
        if (!is.null(n_dimred))
        {
            if (length(n_dimred) == 1L) n_dimred <- seq_len(n_dimred)
            mat <- mat[, n_dimred, drop = FALSE]
        }
    } else {
        mat <- assay(y, exprs_values)
    }

    # save BPPARAM
    oldbp <- getAutoBPPARAM()
    setAutoBPPARAM(BPPARAM)
    on.exit(setAutoBPPARAM(oldbp))
    if (!bpisup(BPPARAM) && !is(BPPARAM, "MulticoreParam"))
    {
        bpstart(BPPARAM)
        on.exit(bpstop(BPPARAM), add=TRUE)
    }
    if (!transposed)
    {
        if (verbose)
            .cat("Select top ", ntop, " features with the highest variances ...")
        cv <- rowVars(mat)
        if (is.null(subset_row))
            subset_row <- sort(head(order(cv, decreasing=TRUE), ntop))
        mat <- mat[subset_row, , drop=FALSE]
        cv <- cv[subset_row]
        if (scale)
        {
            flag <- cv >= 1e-08
            mat <- mat[flag, , drop=FALSE]/sqrt(cv[flag])
            cv <- rep(1, nrow(mat))
        }
        mat <- t(mat)
    } else {
        cv <- colVars(mat)
    }

    # do PCA
    if (verbose)
        cat("Start PCA on the covariance matrix ...\n")
    if (is.null(BSPARAM))
    {
        pca <- x_runsvd(mat, ncomponents, scale=scale)
    } else {
        # use BiocSingular::runPCA instead
        pca <- runPCA(mat, rank=ncomponents, BSPARAM=BSPARAM, BPPARAM=BPPARAM)
    }

    # PCA results
    varExplained <- pca$sdev^2
    percentVar <- varExplained/sum(cv) * 100
    pcs <- pca$x
    rownames(pcs) <- rownames(mat)
    attr(pcs, "varExplained") <- varExplained
    attr(pcs, "percentVar") <- percentVar
    rownames(pca$rotation) <- colnames(mat)
    attr(pcs, "rotation") <- pca$rotation

    # output
    reducedDim(sce, name) <- pcs
    sce
}

#######################################################################
#
# Package name: SCArray
#
# Description:
#     Large-scale single-cell RNA-seq data manipulation with GDS files
#
# Copyright (C) 2020-2023    Xiuwen Zheng (@AbbVie-ComputationalGenomics)
# License: GPL-3
#


#######################################################################
# Class definition

setClass("SCArrayFileClass", contains="gds.class")

# test the validity of objects
setValidity("SCArrayFileClass", function(object)
    {
        if (!inherits(object, "gds.class"))
            return("'object' should be inherited from 'gds.class'.")
        TRUE
    }
)

# to avoid dropping the names in S3 class 'gds.class'
setMethod("updateObject", "SCArrayFileClass",
    function(object, ..., verbose=FALSE) object)



#######################################################################
# Class definition
# See the vignette of the DelayedArray package
#

# if the file is open, no action internally
.reopen <- function(x) gdsfmt:::.reopen(x@gds)

# slot member access
.gds      <- function(x) x@gds
.filename <- function(x) x@filename
.varname  <- function(x) x@varname
.dim      <- function(x) x@dim


# define SCArraySeed class
setClass("SCArraySeed", contains="Array",
    slots = c(
        gds = "SCArrayFileClass",
        filename = "character",
        varname = "character",
        dim = "integer"
    )
)

setClass("SC_GDSArray", contains="DelayedArray")

setClass("SC_GDSMatrix", contains=c("DelayedMatrix", "SC_GDSArray"))



# set the DelayedArray function
setMethod("DelayedArray", "SCArraySeed",
    function(seed) new_DelayedArray(seed, Class="SC_GDSArray")
)


# show method for SCArraySeed object
setMethod("show", "SCArraySeed", function(object)
    {
        .cat("SCArraySeed\n",
            "File: ", .filename(object), "\n",
            "Array node: ", .varname(object), "\n",
            "Dim: ", paste(.dim(object), collapse=" x "))
    }
)


# extract a dense array from DelayedArray
.extract_array_sc_seed <- function(x, index)
{
    # check
    stopifnot(is.list(index), !anyNA(index))
    ans_dim <- DelayedArray:::get_Nindex_lengths(index, dim(x))
    # reopen the file if needed
    .reopen(x)
    # read
    if (any(ans_dim == 0L))
    {
        tp <- objdesp.gdsn(index.gdsn(.gds(x), .varname(x)))$type
        ans <- switch(as.character(tp),
            Raw=raw(), Integer=integer(), Logical=logical(),
            Real=double(), String=character(),
            stop("Unsupported data type: ", tp))
        dim(ans) <- ans_dim
    } else {
        nd <- index.gdsn(.gds(x), .varname(x))
        ans <- readex.gdsn(nd, index, .sparse=FALSE)
        if (!is.array(ans))  # ans must be an array
            dim(ans) <- ans_dim
    }
    ans
}

setMethod("extract_array", "SCArraySeed", .extract_array_sc_seed)


# return whether the array is sparse or not
.is_sparse_sc_seed <- function(x)
{
    # reopen the file if needed
    .reopen(x)
    # whether is a sparse array
    is.sparse.gdsn(index.gdsn(x@gds, x@varname))
}

setMethod("is_sparse", "SCArraySeed", .is_sparse_sc_seed)


# extract sparse data as COO_SparseArray object
.extract_sparse_sc_seed <- function(x, index)
{
    # check
    stopifnot(is.list(index), !anyNA(index))
    ans_dim <- DelayedArray:::get_Nindex_lengths(index, dim(x))
    # reopen the file if needed
    .reopen(x)
    # read
    if (any(ans_dim == 0L))
    {
        tp <- objdesp.gdsn(index.gdsn(.gds(x), .varname(x)))$type
        ans <- switch(as.character(tp),
            Raw=raw(), Integer=integer(), Logical=logical(),
            Real=double(), String=character(),
            stop("Unsupported data type: ", tp))
        COO_SparseArray(ans_dim, nzdata=ans)
    } else {
        nd <- index.gdsn(.gds(x), .varname(x))
        ans <- readex.gdsn(nd, index, .sparse=TRUE)
        if (inherits(ans, "gds_sparse_nz_class"))
        {
            # ans is a list(nzdata, nzindex)
            ans <- COO_SparseArray(ans_dim, ans$nzindex, ans$nzdata, check=FALSE)
            as(ans, "SparseArray")
        } else {
            # ans could be a dense array, dgCMatrix or lgCMatrix
            as(ans, "SparseArray")
        }
    }
}

setMethod("extract_sparse_array", "SCArraySeed", .extract_sparse_sc_seed)

# SCArraySeed constructor
SCArraySeed <- function(gds, varname)
{
    # check gds
    stopifnot(inherits(gds, "SCArrayFileClass"))
    # check varname
    stopifnot(is.character(varname), length(varname)==1L, !is.na(varname))
    nd <- index.gdsn(gds, varname, silent=TRUE)
    if (is.null(nd))
        stop("No '", varname, "'")
    # check dimension
    dp <- objdesp.gdsn(nd)
    if (!dp$is.array)
        stop("'", varname, "' is not an array.")
    dm <- dp$dim
    # output
    new2("SCArraySeed", gds=gds, filename=gds$filename, varname=varname, dim=dm)
}


setMethod("path", "SCArraySeed", function(object) object@filename)
setMethod("path", "SCArrayFileClass", function(object) object$filename)

#######################################################################
#
# Package name: SCArray
#
# Description:
#     Large-scale single-cell RNA-seq data manipulation with GDS files
#
# Copyright (C) 2020-2023    Xiuwen Zheng (@AbbVie-ComputationalGenomics)
# License: GPL-3
#


# Internal
q_rhdf5 <- quote(suppressPackageStartupMessages(
    require("rhdf5", quietly=TRUE)))
q_HDF5Array <- quote(suppressPackageStartupMessages(
    require("HDF5Array", quietly=TRUE)))


#######################################################################
# Internal functions
#

.cat <- function(...) cat(..., "\n", sep="")

.plural <- function(num) if (num > 1L) "s" else ""

.pretty <- function(x) prettyNum(x, big.mark=",", scientific=FALSE)


# return total # of features, and total # of samples
.gettotnum <- function(gdsfile)
{
    nfeat <- objdesp.gdsn(index.gdsn(gdsfile, "feature.id"))$dim
    if (length(nfeat) != 1L)
        stop("Invalid dimension of 'feature.id'.")
    nsamp <- objdesp.gdsn(index.gdsn(gdsfile, "sample.id"))$dim
    if (length(nsamp) != 1L)
        stop("Invalid dimension of 'sample.id'.")
    c(nfeat, nsamp)
}


# add data.frame or DataFrame to a GDS node
.add_dframe <- function(nd, dat, compress, verbose, prefix="")
{
    for (i in seq_len(NCOL(dat)))
    {
        nm <- paste0(prefix, names(dat)[i])
        nm <- gsub("/", "_", nm, fixed=TRUE)
        obj <- dat[[i]]
        if (is.data.frame(obj) || is(obj, "DataFrame"))
        {
            .add_dframe(nd, obj, compress, verbose, paste0(nm, "."))
        } else if (is.matrix(obj) || is(obj, "Matrix"))
        {
            ss <- colnames(obj)
            if (is.null(ss)) ss <- paste0("c", seq_len(ncol(obj)))
            ss <- make.unique(ss)
            for (j in seq_len(ncol(obj)))
            {
                v <- obj[, j]
                s <- paste0(nm, ".", ss[j])
                if (verbose)
                    .cat("    ", s, "\t[", storage.mode(v), "]")
                add.gdsn(nd, s, v, compress=compress, closezip=TRUE)
            }
        } else {
            if (verbose)
                .cat("    ", nm, "\t[", storage.mode(obj), "]")
            add.gdsn(nd, nm, obj, compress=compress, closezip=TRUE)
        }
    }
    invisible()
}



#######################################################################
# Open a SCArray GDS file
#
scOpen <- function(gdsfn, readonly=TRUE, allow.duplicate=TRUE)
{
    # check
    stopifnot(is.character(gdsfn), length(gdsfn)==1L)
    stopifnot(is.logical(readonly), length(readonly)==1L)
    stopifnot(is.logical(allow.duplicate), length(allow.duplicate)==1L)

    # open the file
    ans <- openfn.gds(gdsfn, readonly=readonly, allow.fork=TRUE,
        allow.duplicate=allow.duplicate, use.abspath=FALSE)

    # check the file format
    a <- get.attr.gdsn(ans$root)
    if (!is.null(a$FileFormat))
    {
        if (identical(a$FileFormat, "SNP_ARRAY"))
            stop("It is a SNP GDS file, please use SNPRelate::snpgdsOpen().")
        if (identical(a$FileFormat, "SEQ_ARRAY"))
            stop("It is a SeqArray GDS file, please use SeqArray::seqOpen().")
        if (!identical(a$FileFormat, "SC_ARRAY"))
            stop("'FileFormat' should be 'SC_ARRAY'")
    }

    # output
    new("SCArrayFileClass", ans)
}


#######################################################################
# Close the SCArray GDS file
#
scClose <- function(gdsfile)
{
    # check
    stopifnot(inherits(gdsfile, "SCArrayFileClass"))
    # close the GDS file
    closefn.gds(gdsfile)
}


#######################################################################
# Get an DelayedArray instance
#
scArray <- function(gdsfile, varname)
{
    # check
    if (is.character(gdsfile))
    {
        f <- openfn.gds(gdsfile, readonly=TRUE, allow.fork=TRUE,
            allow.duplicate=TRUE, use.abspath=FALSE)
        gdsfile <- new("SCArrayFileClass", f)
    } else if (identical(class(gdsfile), "gds.class"))
    {
        # should be exactly gds.class
        gdsfile <- new("SCArrayFileClass", gdsfile)
    }
    if (!inherits(gdsfile, "SCArrayFileClass"))
        stop("'gdsfile' should be a file name, gds.class, or SCArrayFileClass.")
    # new SC_GDSMatrix
    seed <- SCArraySeed(gdsfile, varname)
    as(DelayedArray(seed), "SC_GDSArray")
}


#######################################################################
# Get an SingleCellExperiment/SummarizedExperiment instance
#
scExperiment <- function(gdsfile, sce=TRUE, use.names=TRUE, load.row=TRUE,
    load.col=TRUE)
{
    # check
    if (is.character(gdsfile))
        gdsfile <- scOpen(gdsfile, readonly=TRUE, allow.duplicate=TRUE)
    stopifnot(inherits(gdsfile, "SCArrayFileClass"))
    stopifnot(is.logical(sce), length(sce)==1L)
    stopifnot(is.logical(use.names), length(use.names)==1L)
    stopifnot(is.logical(load.row), length(load.row)==1L)
    stopifnot(is.logical(load.col), length(load.col)==1L)

    # dimnames
    dm <- .gettotnum(gdsfile)
    feat_id <- samp_id <- NULL
    if (use.names)
    {
        feat_id <- read.gdsn(index.gdsn(gdsfile, "feature.id"))
        samp_id <- read.gdsn(index.gdsn(gdsfile, "sample.id"))
    }
    # list all assays
    nm <- ls.gdsn(gdsfile, include.dirs=FALSE)
    x <- vapply(nm, FUN=function(s) {
        identical(objdesp.gdsn(index.gdsn(gdsfile, s))$dim, dm)
    }, FUN.VALUE=TRUE)
    lst <- lapply(nm[x], function(s) {
        m <- scArray(gdsfile, s)
        rownames(m) <- feat_id; colnames(m) <- samp_id
        if (length(dim(m))==2L)
            m <- as(m, SMatrix)
        else
            m <- as(m, SClass)
        m
    })
    names(lst) <- nm[x]

    # load rowData
    rowdat <- NULL
    if (isTRUE(load.row))
    {
        nd <- index.gdsn(gdsfile, "feature.data", silent=TRUE)
        if (!is.null(nd))
        {
            nmlst <- ls.gdsn(nd, include.hidden=FALSE)
            v <- lapply(nmlst, function(nm) read.gdsn(index.gdsn(nd, nm)))
            names(v) <- nmlst
            rowdat <- DataFrame(v, row.names=feat_id)
        }
    }

    # load colData
    coldat <- NULL
    if (isTRUE(load.col))
    {
        nd <- index.gdsn(gdsfile, "sample.data", silent=TRUE)
        if (!is.null(nd))
        {
            nmlst <- ls.gdsn(nd, include.hidden=FALSE)
            v <- lapply(nmlst, function(nm) read.gdsn(index.gdsn(nd, nm)))
            names(v) <- nmlst
            coldat <- DataFrame(v, row.names=samp_id)
        }
    }

    # output
    if (isTRUE(sce))
    {
        # return a SingleCellExperiment object
        if (is.null(coldat))
            SingleCellExperiment(assays=lst, rowData=rowdat)
        else
            SingleCellExperiment(assays=lst, rowData=rowdat, colData=coldat)
    } else {
        # return a SummarizedExperiment object
        if (is.null(coldat))
            SummarizedExperiment(assays=lst, rowData=rowdat)
        else
            SummarizedExperiment(assays=lst, rowData=rowdat, colData=coldat)
    }
}


#######################################################################
# Convert an R object to a single-cell GDS file
# the input R object can be matrix, DelayedMatrix, SummarizedExperiment or
#     SingleCellExperiment
#
scConvGDS <- function(obj, outfn, assay.name=NULL, save.sp=TRUE,
    type=c("float32", "float64", "int32"), compress="LZMA_RA", clean=TRUE,
    verbose=TRUE)
{
    # check
    stopifnot(is.matrix(obj) | inherits(obj, "Matrix") |
        is(obj, "DelayedMatrix") | is(obj, "SingleCellExperiment") |
        is(obj, "SummarizedExperiment"))
    stopifnot(is.character(outfn), length(outfn)==1L)
    stopifnot(is.null(assay.name) || is.character(assay.name))
    stopifnot(is.logical(save.sp), length(save.sp)==1L)
    type <- match.arg(type)
    stopifnot(is.character(compress), length(compress)==1L)
    stopifnot(is.logical(clean), length(clean)==1L)
    stopifnot(is.logical(verbose), length(verbose)==1L)

    # row and column names
    rowdat <- coldat <- metadat <- NULL
    nr <- nrow(obj); rownm <- rownames(obj)
    nc <- ncol(obj); colnm <- colnames(obj)
    lst <- list()
    if (is.matrix(obj) || inherits(obj, "Matrix") || is(obj, "DelayedMatrix"))
    {
        assaylst <- list(counts=obj)
    } else if (is(obj, "SingleCellExperiment") | is(obj, "SummarizedExperiment"))
    {
        assaylst <- assays(obj)
        rowdat <- rowData(obj)
        coldat <- colData(obj)
        metadat <- metadata(obj)
    } else {
        stop("Not support the input: ", class(obj)[1L])
    }

    # check row and column names
    if (anyDuplicated(rownm))
    {
        rownm <- make.unique(rownm)
        warning("rownames are not unique, and 'make.unique()' is called",
            immediate.=TRUE)
    }
    if (anyDuplicated(colnm))
    {
        colnm <- make.unique(colnm)
        warning("colnames are not unique, and 'make.unique()' is called",
            immediate.=TRUE)
    }

    # need rownames and colnames
    if (is.null(rownm))
    {
        rownm <- paste0("g", seq_len(nr))
        warning('rownames=NULL, use c("g1", "g2", ...) instead.', immediate.=TRUE)
    }
    if (is.null(colnm))
    {
        colnm <- paste0("c", seq_len(nc))
        warning('colnames=NULL, use c("c1", "c2", ...) instead.', immediate.=TRUE)
    }

    # create a gds file
    if (verbose) .cat("Output: ", outfn)
    outf <- createfn.gds(outfn)
    on.exit(closefn.gds(outf))
    put.attr.gdsn(outf$root, "FileFormat", "SC_ARRAY")
    put.attr.gdsn(outf$root, "FileVersion", "v1.0")
    if (verbose) .cat("Compression: ", compress)

    # add feature and sample IDs
    add.gdsn(outf, "feature.id", rownm, compress=compress, closezip=TRUE)
    add.gdsn(outf, "sample.id", colnm, compress=compress, closezip=TRUE)
    if (verbose) .cat("Dimension: ", nr, " x ", nc)

    # assays
    if (is.null(assay.name)) assay.name <- names(assaylst)
    s <- setdiff(assay.name, names(assaylst))
    assay.name <- intersect(assay.name, names(assaylst))
    assay.name <- setdiff(assay.name, c("feature.id", "sample.id",
        "feature.data", "sample.data", "meta.data"))
    if (verbose)
    {
        .cat("Assay List [", paste(assay.name, collapse=","), "]:")
    }
    if (length(s))
    {
        s <- paste(s, collapse=",")
        warning("No [", s, "] available.", call.=FALSE, immediate.=TRUE)
    }
    # check counts & logcounts
    if (all(c("counts", "logcounts") %in% assay.name))
    {
        warning("'logcounts' should be excluded, since it can be ",
            "generated from 'counts'.", call.=FALSE, immediate.=TRUE)
    }

    # for-each assay
    for (nm in assay.name)
    {
        if (verbose) cat("    ", nm, "\t!", sep="")
        st <- type
        if (save.sp)
        {
            st <- switch(type, float32="sp.real32", float64="sp.real64",
                int32="sp.int32", stop("Invalid 'type': ", type))
        }
        nd <- add.gdsn(outf, nm, valdim=c(nr, 0L), compress=compress,
            storage=st)
        mt <- assaylst[[nm]]
        if (verbose)
            pb <- txtProgressBar(min=0L, max=ncol(mt), width=50L)
        blockApply(mt, function(x) {
            append.gdsn(nd, x)
            if (verbose)
                setTxtProgressBar(pb, start(currentViewport())[2L])
            NULL
        }, grid=colAutoGrid(mt), BPPARAM=NULL)
        readmode.gdsn(nd)
        if (verbose)
        {
            setTxtProgressBar(pb, ncol(mt))
            close(pb)
            cat("    |"); print(nd)
        }
    }

    # add rowData to feature.data
    nfd <- addfolder.gdsn(outf, "feature.data")
    if (!is.null(rowdat))
    {
        if (verbose) .cat("rowData:")
        .add_dframe(nfd, rowdat, compress, verbose)
    }

    # add colData to sample.data
    nfd <- addfolder.gdsn(outf, "sample.data")
    if (!is.null(coldat))
    {
        if (verbose) .cat("colData:")
        .add_dframe(nfd, coldat, compress, verbose)
    }

    # add metadata to meta.data
    nfd <- addfolder.gdsn(outf, "meta.data")
    if (length(metadat) > 0L)
    {
        if (verbose) .cat("metadata:")
        for (i in seq_along(metadat))
        {
            nm <- names(metadat)[i]
            v <- metadat[[i]]
            if (is(v, "DataFrame")) v <- as.data.frame(v)
            if (verbose)
                .cat("    ", nm, "\t[", storage.mode(v), "]")
            add.gdsn(nfd, nm, v, compress=compress, closezip=TRUE)
        }
    }

    # close file
    on.exit()
    closefn.gds(outf)
    if (isTRUE(clean)) cleanup.gds(outfn, verbose=FALSE)
    cat("Done.\n")

    # output
    invisible(normalizePath(outfn))
}


#######################################################################
# Convert CellRanger Market Exchange Format (MEX) files to GDS
#
scMEX2GDS <- function(feature_fn, barcode_fn, mtx_fn, outfn,
    feature_colnm=c("id", "gene", "feature_type"),
    type=c("float32", "float64", "int32"), compress="LZMA_RA", clean=TRUE,
    verbose=TRUE)
{
    # check
    stopifnot(is.character(feature_fn), length(feature_fn)==1L)
    stopifnot(is.character(barcode_fn), length(barcode_fn)==1L)
    stopifnot(is.character(mtx_fn), length(mtx_fn)==1L)
    stopifnot(is.character(outfn), length(outfn)==1L)
    stopifnot(is.character(feature_colnm))
    type <- match.arg(type)
    stopifnot(is.character(compress), length(compress)==1L)
    stopifnot(is.logical(clean), length(clean)==1L)
    stopifnot(is.logical(verbose), length(verbose)==1L)

    # load features
    if (anyDuplicated(feature_colnm))
        stop("'feature_colnm' should be unique.")
    if (length(feature_colnm) == 0L)
        feature_colnm <- "id"
    if (verbose) .cat("Load ", sQuote(feature_fn))
    ft <- read.delim(feature_fn, header=FALSE, stringsAsFactors=FALSE)
    if (ncol(ft) > length(feature_colnm))
    {
        feature_colnm <- c(feature_colnm,
            paste0("var", seq.int(length(feature_colnm)+1L,
                length.out=ncol(ft)-length(feature_colnm))))
    }
    colnames(ft) <- feature_colnm[seq_len(ncol(ft))]
    if (!("id" %in% colnames(ft)))
        stop("No id found in the feature file.")
    if (anyDuplicated(ft$id))
        stop("The first column of feature file is used as feature.id, and should be unique.")

    # load barcodes
    if (verbose) .cat("Load ", sQuote(barcode_fn))
    bt <- read.delim(barcode_fn, header=FALSE, stringsAsFactors=FALSE)
    if (anyDuplicated(bt$V1))
        stop("The first column of barcode file is used as sample.id, and should be unique.")

    # load count matrix
    if (verbose) .cat("Load ", sQuote(mtx_fn))
    mt <- readMM(mtx_fn)
    if (verbose)
    {
        nz <- nnzero(mt)
        .cat("    ", nrow(mt), "x", ncol(mt), ", # of nonzeros: ",
            nz, sprintf(" (%.4f%%)", 100*nz/prod(dim(mt))))
    }
    if (nrow(mt) != nrow(ft))
        stop("# of rows should be as the same as feature file.")
    if (ncol(mt) != nrow(bt))
        stop("# of columns should be as the same as # of rows in barcode file.")

    # create a gds file
    if (verbose) .cat("Output: ", outfn)
    outf <- createfn.gds(outfn)
    on.exit(closefn.gds(outf))
    put.attr.gdsn(outf$root, "FileFormat", "SC_ARRAY")
    put.attr.gdsn(outf$root, "FileVersion", "v1.0")
    if (verbose) .cat("Compression: ", compress)

    # add feature and sample IDs
    add.gdsn(outf, "feature.id", ft$id, compress=compress, closezip=TRUE)
    add.gdsn(outf, "sample.id", bt$V1, compress=compress, closezip=TRUE)

    # assays
    if (verbose) .cat("Count matrix ...")
    st <- switch(type, float32="sp.real32", float64="sp.real64",
        int32="sp.int32", stop("Invalid 'type': ", type))
    nd <- add.gdsn(outf, "counts", valdim=c(nrow(mt), 0L), compress=compress,
        storage=st)
    gd <- colAutoGrid(mt)
    if (verbose)
    {
        pb <- txtProgressBar(0L, length(gd), style=3L, width=64L, file=stderr())
        blockReduce(function(x, v)
            {
                append.gdsn(nd, x)
                setTxtProgressBar(pb, currentBlockId())
                NULL
            }, mt, init=NULL, grid=gd, as.sparse=FALSE)
        close(pb)
    } else {
        blockReduce(function(x, v) append.gdsn(nd, x),
            mt, init=NULL, grid=gd, as.sparse=FALSE)
    }
    readmode.gdsn(nd)
    if (verbose) { cat("    |"); print(nd) }

    # add rowData to feature.data
    nfd <- addfolder.gdsn(outf, "feature.data")
    for (i in seq.int(2L, length.out=ncol(ft)-1L))
    {
        add.gdsn(nfd, names(ft)[i], ft[[i]], compress=compress,
            closezip=TRUE)
    }

    # add colData to sample.data
    nfd <- addfolder.gdsn(outf, "sample.data")
    for (i in seq_len(ncol(bt)-1L))
    {
        add.gdsn(nfd, paste0("var", i), bt[[i+1L]], compress=compress,
            closezip=TRUE)
    }

    # close file
    on.exit()
    closefn.gds(outf)
    if (isTRUE(clean)) cleanup.gds(outfn, verbose=FALSE)
    cat("Done.\n")

    # output
    invisible(normalizePath(outfn))
}


#######################################################################
# Convert CellRanger HDF5 files to GDS
#
scHDF2GDS <- function(h5_fn, outfn, group=c("matrix", "mm10"),
    feature_path=character(),
    type=c("float32", "float64", "int32"), compress="LZMA_RA", clean=TRUE,
    verbose=TRUE)
{
    # check
    stopifnot(is.character(h5_fn), length(h5_fn)==1L)
    stopifnot(is.character(outfn), length(outfn)==1L)
    stopifnot(is.character(group), length(group)>=1L)
    stopifnot(is.character(feature_path))
    if (anyDuplicated(feature_path))
        stop("'feature_path' should be unique.")
    type <- match.arg(type)
    stopifnot(is.character(compress), length(compress)==1L)
    stopifnot(is.logical(clean), length(clean)==1L)
    stopifnot(is.logical(verbose), length(verbose)==1L)

    # check packages
    if (!eval(q_rhdf5))
        stop("The package 'rhdf5' and 'HDF5Array' should be installed.")
    if (!eval(q_HDF5Array))
        stop("The package 'HDF5Array' should be installed.")

    # load HDF5 count matrix
    a <- rhdf5::h5ls(h5_fn, all=TRUE)
    a$group[a$group == "/"] <- ""
    a$path <- substring(paste(a$group, a$name, sep="/"), 2L)
    sep <- ifelse(grepl("/$", group), "", "/")
    if (verbose)
    {
        .cat("Load ", sQuote(h5_fn))
        .cat("    (", .pretty(file.size(h5_fn)), " bytes)")
    }
    g <- intersect(group, a$path)
    if (length(g) == 0L)
        stop("No hdf5 group for sparse matrix.")
    group <- g[1L]
    if (verbose) cat("   ", group)
    mt <- HDF5Array::H5SparseMatrix(h5_fn, group)
    if (verbose)
        .cat("    [", class(mt)[1L], ", ", nrow(mt), " x ", ncol(mt), "]")

    # load barcodes
    nm <- paste(group, "barcodes", sep=sep)
    if (verbose) .cat("    ", nm)
    bt <- rhdf5::h5read(h5_fn, nm)
    if (anyDuplicated(bt))
        stop("'barcodes' should be unique.")
    if (length(bt) != ncol(mt))
        stop("Num. of columns in the count matrix should be # of barcodes.")

    # load features
    if (length(feature_path) == 0L)
    {
        feature_path <- c("genes", "gene_names",
            "features/id", "features/name", "features/feature_type",
            "features/genome", "features/")
    }
    test_path <- paste(group, feature_path, sep="/")
    z <- grepl("/$", test_path)
    test_path2 <- test_path[z]   # search the sub directory
    test_path  <- test_path[!z]
    used <- intersect(test_path, a$path)
    for (nm in test_path2)
    {
        s <- a$path[substr(a$path, 1L, nchar(nm)) == nm]
        z <- substring(s, nchar(nm)+1L)
        used <- c(used, s[!grepl("^_", z) & !grepl("/", z, fixed=TRUE)])
    }
    used <- unique(used)
    if (length(used) == 0L)
        stop("'No valid 'feature_path'.")
    ft <- lapply(used, function(nm) {
        .cat("    ", nm)
        v <- rhdf5::h5read(h5_fn, nm)
        if (is.vector(v) || length(dim(v))==1L)
        {
            if (length(v) != nrow(mt))
                stop(sQuote(nm), " should have ", nrow(mt), " values.")
        } else {
            stop(sQuote(nm), " should be a vector.")
        }
        v
    })
    names(ft) <- basename(used)
    if (anyDuplicated(ft[[1L]]))
        stop(sQuote(used[1L]), " should be unique.")

    # create a gds file
    if (verbose) .cat("Output: ", outfn)
    outf <- createfn.gds(outfn)
    on.exit(closefn.gds(outf))
    put.attr.gdsn(outf$root, "FileFormat", "SC_ARRAY")
    put.attr.gdsn(outf$root, "FileVersion", "v1.0")
    if (verbose) .cat("Compression: ", compress)

    # add feature and sample IDs
    add.gdsn(outf, "feature.id", ft[[1L]], compress=compress, closezip=TRUE)
    add.gdsn(outf, "sample.id", bt, compress=compress, closezip=TRUE)

    # assays
    if (verbose) .cat("Count matrix ...")
    st <- switch(type, float32="sp.real32", float64="sp.real64",
        int32="sp.int32", stop("Invalid 'type': ", type))
    nd <- add.gdsn(outf, "counts", valdim=c(nrow(mt), 0L), compress=compress,
        storage=st)
    gd <- colAutoGrid(mt)
    if (verbose)
    {
        pb <- txtProgressBar(0L, length(gd), style=3L, width=64L, file=stderr())
        blockReduce(function(x, v)
            {
                append.gdsn(nd, x)
                setTxtProgressBar(pb, currentBlockId())
                NULL
            }, mt, init=NULL, grid=gd, as.sparse=FALSE)
        close(pb)
    } else {
        blockReduce(function(x, v) append.gdsn(nd, x),
            mt, init=NULL, grid=gd, as.sparse=FALSE)
    }
    readmode.gdsn(nd)
    if (verbose) { cat("    |"); print(nd) }

    # add rowData to feature.data
    nfd <- addfolder.gdsn(outf, "feature.data")
    for (i in seq.int(2L, length.out=length(ft)-1L))
    {
        add.gdsn(nfd, names(ft)[i], ft[[i]], compress=compress,
            closezip=TRUE)
    }

    # add colData to sample.data
    addfolder.gdsn(outf, "sample.data")

    # close file
    on.exit()
    closefn.gds(outf)
    if (isTRUE(clean)) cleanup.gds(outfn, verbose=FALSE)
    .cat("Done.")

    # output
    invisible(normalizePath(outfn))
}


#######################################################################
# Wrap the DelayedArray object with SC_GDSArray
#
scObj <- function(obj, verbose=FALSE)
{
    # check
    stopifnot(is.logical(verbose), length(verbose)==1L)
    # do
    if (is(obj, DClass))
    {
        if (is(obj, "DelayedMatrix") && !is(obj, SMatrix))
        {
            obj <- as(obj, SMatrix)
            if (verbose)
                cat("==> SC_GDSMatrix\n")
        } else if (is(obj, DClass) && !is(obj, SClass))
        {
            obj <- as(obj, SClass)
            if (verbose)
                cat("==> SC_GDSArray\n")
        }
        obj
    } else if (is(obj, "SummarizedExperiment"))
    {
        lst <- assays(obj)
        nm <- names(lst)
        for (i in seq_along(lst))
        {
            v <- lst[[i]]
            if (is(v, "DelayedMatrix") && !is(v, SMatrix))
            {
                assay(obj, i) <- as(v, SMatrix)
                if (verbose)
                    .cat(nm[i], " ==> SC_GDSMatrix")
            } else if (is(v, DClass) && !is(v, SClass))
            {
                assay(obj, i) <- as(v, SClass)
                if (verbose)
                    .cat(nm[i], " ==> SC_GDSArray")
            }
        }
        obj
    } else
        stop("obj should be a SummarizedExperiment object.")
}


#######################################################################

scNumSplit <- function(num, BPPARAM=getAutoBPPARAM())
{
    # check
    stopifnot(is.numeric(num), length(num)==1L)
    # number of workers
    if (is.null(BPPARAM))
        nw <- 1L
    else if (is.numeric(BPPARAM))
        nw <- BPPARAM
    else if (is(BPPARAM, "BiocParallelParam"))
        nw <- bpnworkers(BPPARAM)
    else {
        stop(
        "'BPPARAM' should be NULL, an integer or a BiocParallelParam object.")
    }
    # list
    .Call(c_get_split, num, nw, double(nw+1L))
}

scSetMax <- function(x, vmax)
{
    # check
    stopifnot(is(x, "SC_GDSArray"))
    stopifnot(is.numeric(vmax), length(vmax)==1L)
    if (is.na(vmax)) return(x)
    # set a function
    f <- function(a) base::pmin(a, vmax)
    env <- new.env(parent=globalenv())  # need an environment only having vmax
    assign("vmax", vmax, envir=env)
    environment(f) <- env
    # output
    .sc_val(DelayedArray:::stash_DelayedUnaryIsoOpStack(x, f))
}

scSetMin <- function(x, vmin)
{
    # check
    stopifnot(is(x, "SC_GDSArray"))
    stopifnot(is.numeric(vmin), length(vmin)==1L)
    if (is.na(vmin)) return(x)
    # set a function
    f <- function(a) base::pmax(a, vmin)
    env <- new.env(parent=globalenv())  # need an environment only having vmin
    assign("vmin", vmin, envir=env)
    environment(f) <- env
    # output
    .sc_val(DelayedArray:::stash_DelayedUnaryIsoOpStack(x, f))
}

scSetBounds <- function(x, vmin=NaN, vmax=NaN)
{
    # check
    stopifnot(is(x, "SC_GDSArray"))
    stopifnot(is.numeric(vmin), length(vmin)==1L)
    stopifnot(is.numeric(vmax), length(vmax)==1L)
    if (!is.na(vmin) && !is.na(vmax))
    {
        # set a function
        f <- function(a) base::pmin(base::pmax(a, vmin), vmax)
        env <- new.env(parent=globalenv())  # need an environment only having vmin, vmax
        assign("vmin", vmin, envir=env)
        assign("vmax", vmax, envir=env)
        environment(f) <- env
        # output
        .sc_val(DelayedArray:::stash_DelayedUnaryIsoOpStack(x, f))
    } else if (!is.na(vmin))
    {
        scSetMin(x, vmin)  # output
    } else if (!is.na(vmax))
    {
        scSetMax(x, vmax)  # output
    } else
        x
}

scReplaceNA <- function(x, v=0L)
{
    # check
    stopifnot(is(x, "SC_GDSArray"))
    stopifnot(is.numeric(v), length(v)==1L)
    if (is.na(v)) return(x)
    # set a function
    f <- function(a) { a[is.na(a)] <- v; a }
    env <- new.env(parent=globalenv())  # need an environment only having v
    assign("v", v, envir=env)
    environment(f) <- env
    # output
    .sc_val(DelayedArray:::stash_DelayedUnaryIsoOpStack(x, f))
}

suppressPackageStartupMessages(library(RUnit))
suppressPackageStartupMessages(library(SCArray))
suppressPackageStartupMessages(library(SingleCellExperiment))
suppressPackageStartupMessages(library(DelayedMatrixStats))


test_sce_matrix <- function()
{
	# a GDS file for SingleCellExperiment
	fn <- system.file("extdata", "example.gds", package="SCArray")

	sce <- scExperiment(fn)
	mt <- assays(sce)$counts

	cM <- unname(colMeans(mt))
	cM2 <- colMeans2(mt)
	checkEquals(cM, cM2, "counts: colmean")

	rM <- unname(rowMeans(mt))
	rM2 <- rowMeans2(mt)
	checkEquals(rM, rM2, "counts: rowmean")
}

#######################################################################
#
# Package name: SCArray
#
# Description:
#     Large-scale single-cell RNA-seq data manipulation with GDS files
#
# Copyright (C) 2023    Xiuwen Zheng (@AbbVie-ComputationalGenomics)
# License: GPL-3
#


#######################################################################

.is_mem_matrix <- function(m)
{
    is.matrix(m) || is(m, "Matrix")
}

.is_matrix <- function(m)
{
    is.matrix(m) || is(m, "Matrix") || is(m, "DelayedMatrix")
}



#######################################################################

.crossprod_x_row_seq <- function(x)
{
    gd <- rowAutoGrid(x)
    pb <- x_progress(gd)
    if (!is.null(pb)) on.exit(close(pb))
    # block processing
    blockReduce(function(bk, v, pb)
    {
        if (is(bk, "COO_SparseArray")) bk <- as(bk, "SVT_SparseArray")
        if (!is.null(pb))
            setTxtProgressBar(pb, currentBlockId())
        .Call(c_add, v, as.matrix(crossprod(bk)))
    }, x, matrix(0, ncol(x), ncol(x)), grid=gd, as.sparse=NA, pb=pb)
}


.crossprod_x_row_parallel <- function(x, sp, bp)
{
    # run
    lst <- bplapply(sp, function(s, x)
    {
        dm <- dim(x)
        if (s[1L]!=1L || s[2L]!=dm[1L])
        {
            # sub rows
            x <- x[seq.int(s[1L], s[2L]), , drop=FALSE]
        }
        gd <- rowAutoGrid(x)
        if (s[3L]==1L && s[4L]==dm[2L])
        {
            # crossprod the whole matrix
            blockReduce(function(bk, v, ii)
            {
                if (is(bk, "COO_SparseArray")) bk <- as(bk, "SVT_SparseArray")
                .Call(c_add, v, as.matrix(crossprod(bk)))
            }, x, matrix(0, ncol(x), ncol(x)), grid=gd, as.sparse=NA)
        } else {
            # crossprod the sub matrix
            ii <- seq.int(s[3L], s[4L])  # sub columns
            blockReduce(function(bk, v, ii)
            {
                if (is(bk, "COO_SparseArray")) bk <- as(bk, "SVT_SparseArray")
                .Call(c_add, v, as.matrix(crossprod(bk, bk[,ii])))
            }, x, matrix(0, ncol(x), length(ii)), grid=gd, as.sparse=NA, ii=ii)
        }
    }, BPPARAM=bp, x=x)
    # return(list(lst=lst, sp=sp))
    # reduce
    irow <- vapply(sp, `[`, i=3L, 0L)
    iflag <- rep(TRUE, length(irow))
    for (i in unique(irow))
    {
        ii <- which(irow == i)
        k <- ii[1L]
        for (j in ii[-1L])
        {
            lst[[k]] <- .Call(c_add, lst[[k]], lst[[j]])
            iflag[j] <- FALSE
        }
    }
    lst <- lst[iflag]
    # output
    base::Reduce(cbind, lst)
}


# t(x) %*% y, where y = x
x_crossprod_x <- function(x, y)
{
    x_check(x, "Calling SCArray:::x_crossprod_x() with %s ...")
    k <- x_type(x)
    if (k == 2L)
    {
        # efficient direction of 'x' is row, result in [ ncol(x), ncol(x) ]
        bp <- getAutoBPPARAM()
        nworker <- .get_num_worker(bp)
        # split rows & columns (not larger than 2GB)
        ngrp <- floor(min(getAutoBlockSize(), 2^31) / (ncol(x)^2*8))
        sp_r <- scNumSplit(nrow(x), min(ngrp, nworker))
        sp_c <- scNumSplit(ncol(x), floor(nworker/length(sp_r)))
        # do
        if (length(sp_r)!=1L || length(sp_c)!=1L)
        {
            x_msg(sprintf(
                "Distributed to %d processes with (%d x %d) sub matrices ...",
                nworker, length(sp_r), length(sp_c)))
            # split list
            sp <- list()
            for (i in sp_r)
                for (j in sp_c) sp <- c(sp, list(c(i, j)))
            # distribute
            rv <- .crossprod_x_row_parallel(x, sp, bp)
        } else {
            # sequentially
            rv <- .crossprod_x_row_seq(x)
        }
        # output
        s <- colnames(x)
        if (!is.null(s)) dimnames(rv) <- list(s, s)
        rv
    } else {
        crossprod(as(x, DMatrix))
    }
}


################

# x %*% t(y), where y = x
x_tcrossprod_x <- function(x, y)
{
    x_check(x, "Calling SCArray:::x_tcrossprod_x() with %s ...")
    k <- x_type(x)
    if (k == 1L)
    {
        # efficient direction of 'x' is column, result in [ nrow(x), nrow(x) ]
        rv <- blockReduce(function(bk, v)
        {
            if (is(bk, "COO_SparseArray")) bk <- as(bk, "SVT_SparseArray")
            .Call(c_add, v, as.matrix(tcrossprod(bk)))
        }, x, matrix(0.0, nrow(x), nrow(x)), grid=colAutoGrid(x), as.sparse=NA)
        # output
        s <- rownames(x)
        if (!is.null(s)) dimnames(rv) <- list(s, s)
        rv
    } else {
        tcrossprod(as(x, DMatrix))
    }
}


setMethod("crossprod", c(SMatrix, "missing"), x_crossprod_x)
setMethod("crossprod", c(SMatrix, "ANY"), function(x, y) t(x) %*% y)
setMethod("crossprod", c("ANY", SMatrix), function(x, y) t(x) %*% y)

setMethod("tcrossprod", c(SMatrix, "missing"), x_tcrossprod_x)
setMethod("tcrossprod", c(SMatrix, "ANY"), function(x, y) x %*% t(y))
setMethod("tcrossprod", c("ANY", SMatrix), function(x, y) x %*% t(y))


################

# x %*% y, where x is GDS and y is matrix
x_mul_x_y0 <- function(x, y)
{
    x_msg("\\=> Calling SCArray:::x_mul_x_y0()")
    # initialize
    rnames <- rownames(x)
    cnames <- colnames(y)
    if (!is.null(dimnames(x))) dimnames(x) <- NULL
    # if (!is.null(dimnames(y))) dimnames(y) <- list(NULL, NULL)
    # block processing
    gd <- colAutoGrid(x)
    pb <- x_progress(gd)
    if (!is.null(pb)) on.exit(close(pb))
    rv <- blockReduce(function(bk, v, ym, pb)
    {
        if (is(bk, "COO_SparseArray")) bk <- as(bk, "SVT_SparseArray")
        vw <- currentViewport()
        ii <- start(vw)[2L]:end(vw)[2L]
        if (!is.null(pb))
            setTxtProgressBar(pb, currentBlockId())
        .Call(c_add, v, as.matrix(bk %*% ym[ii, , drop=FALSE]))
    }, x, matrix(0, nrow(x), ncol(y)), grid=gd, as.sparse=NA, ym=y, pb=pb)
    # output
    rownames(rv) <- rnames
    colnames(rv) <- cnames
    rv
}


x_multiply_x_yANY <- function(x, y)
{
    # check
    x_check(x, "Calling SCArray:::x_multiply_x_yANY() with %s ...")
    if (!.is_mem_matrix(y))
    {
        if (!is.vector(y))
        {
            stop(paste("Matrix multiplication of a", class(x), "by a",
                class(y), "object is not supported"))
        }
        y <- matrix(y, ncol=1L)
    }
    if (ncol(x) != nrow(y))
        stop("non-conformable arguments")
    # compute ...
    k <- x_type(x)
    if (k == 1L)
    {
        # efficient direction of 'x' is column
        x_mul_x_y0(x, y)
    } else {
        as.matrix(as(x, DMatrix) %*% y)
    }
}

x_multiply_xANY_y <- function(x, y)
{
    # check
    x_check(y, "Calling SCArray:::x_multiply_xANY_y() with %s ...")
    if (!.is_mem_matrix(x))
    {
        if (!is.vector(x))
        {
            stop(paste("Matrix multiplication of a", class(x), "object by a",
                class(y), "is not supported"))
        }
        x <- matrix(x, nrow=1L)
    }
    if (ncol(x) != nrow(y))
        stop("non-conformable arguments")
    # compute ...
    k <- x_type(y)
    if (k == 2L)
    {
        # efficient direction of 'y' is row
        t(x_mul_x_y0(t(y), t(x)))
    } else {
        as.matrix(x %*% as(y, DMatrix))
    }
}

x_multiply_x_y <- function(x, y)
{
    as.matrix(as(x, DMatrix) %*% as(y, DMatrix))
}

setMethod("%*%", c(SMatrix, "ANY"), x_multiply_x_yANY)
setMethod("%*%", c("ANY", SMatrix), x_multiply_xANY_y)
# setMethod("%*%", c(SMatrix, SMatrix), x_multiply_x_y)

#######################################################################
#
# Package name: SCArray
#
# Description:
#     Large-scale single-cell RNA-seq data manipulation with GDS files
#
# Copyright (C) 2021-2023    Xiuwen Zheng (@AbbVie-ComputationalGenomics)
# License: GPL-3
#


#######################################################################

DClass  <- "DelayedArray"
DMatrix <- "DelayedMatrix"
SClass  <- "SC_GDSArray"
SMatrix <- "SC_GDSMatrix"


# For internal use only
setMethod("matrixClass", SClass, function(x) SMatrix)

# Automatic coercion method from GDSArray to GDSMatrix (muted for
# higher dimensions) this function works only when GDSArray is
# 2-dimensional, otherwise it fails.

setAs(SClass, SMatrix, function(from) new(SMatrix, from))
setAs(SMatrix, SClass, function(from) from)
setAs("ANY", SMatrix,
    function(from) as(as(from, SClass), SMatrix))

# setMethod(
#     "DelayedArray", "SCArraySeed",
#     function(seed) new_DelayedArray(seed, Class=SClass)
# )


#######################################################################

.reset_OPS_env <- function(x, varnm)
{
    # find OPS
    if (is(x, "DelayedUnaryIsoOpStack"))
    {
        for (f in x@OPS)
        {
            e <- environment(f)
            if (!is.null(e))
            {
                for (nm in varnm)
                    if (exists(nm, envir=e)) remove(list=nm, envir=e)
            }
        }
        return(TRUE)
    }
    if (is(x, "DelayedUnaryOp"))
        return(.reset_OPS_env(x@seed, varnm))
    # find OP
    if (is(x, "DelayedNaryOp"))
    {
        if (is(x, "DelayedNaryIsoOp"))
        {
            e <- environment(x@OP)
            if (!is.null(e))
            {
                for (nm in varnm)
                    if (exists(nm, envir=e)) remove(list=nm, envir=e)
            }
            return(TRUE)
        }
        x <- x@seeds
    }
    # find next
    if (is.list(x) && !is.array(x))
    {
        for (y in x)
        {
            if (.reset_OPS_env(y, varnm)) return(TRUE)
        }
    }
    FALSE
}


.sc_val <- function(v)
{
    if (is(v, DMatrix) && !is(v, SMatrix))
        as(v, SMatrix)
    else if (is(v, DClass) && !is(v, SClass))
        as(v, SClass)
    else
        v
}

.sc_val_e1 <- function(v)
{
    .reset_OPS_env(v, "e1")
    .sc_val(v)
}

.sc_val_e2 <- function(v)
{
    .reset_OPS_env(v, "e2")
    .sc_val(v)
}



# subsetting
setMethod("[", SClass,
    function(x, i, j, ..., drop=TRUE) .sc_val(callNextMethod()) )
setMethod("[[", SClass,
    function(x, i, j, ...) .sc_val(callNextMethod()) )

# transpose
setMethod("aperm", SClass,
    function(a, perm, ...) .sc_val(callNextMethod()) )

# names<-
setMethod("names<-", SClass, function(x, value) .sc_val(callNextMethod()) )

# dimnames<-
setMethod("dimnames<-", SClass, function(x, value) .sc_val(callNextMethod()) )

# rbind, cbind
setMethod("rbind", SClass, function(...) .sc_val(callNextMethod()) )
setMethod("cbind", SClass, function(...) .sc_val(callNextMethod()) )

# setMethod("bindROWS", SClass, function(...) .sc_val(callNextMethod()) )
# setMethod("bindCOLS", SClass, function(...) .sc_val(callNextMethod()) )


# Ops
setMethod("Ops", c(SClass, "vector"),
    function(e1, e2) .sc_val_e1(callGeneric(as(e1, DClass), e2)) )
setMethod("Ops", c("vector", SClass),
    function(e1, e2) .sc_val_e2(callGeneric(e1, as(e2, DClass))) )
setMethod("Ops", c(SClass, SClass),
    function(e1, e2) .sc_val(callGeneric(as(e1, DClass), as(e2, DClass))) )
setMethod("+", c(SClass, "missing"),    # unary operators "+"
    function(e1, e2) .sc_val_e1(callGeneric(as(e1, DClass))) )
setMethod("-", c(SClass, "missing"),    # unary operators "-"
    function(e1, e2) .sc_val_e1(callGeneric(as(e1, DClass))) )


# Math
setMethods("Math", SClass,
    function(x) .sc_val(callGeneric(as(x, DClass))) )

# pmax2
setMethod("pmax2", c(SClass, "vector"),
    function(e1, e2) .sc_val_e1(callGeneric(as(e1, DClass), e2)) )
setMethod("pmax2", c("vector", SClass),
    function(e1, e2) .sc_val_e2(callGeneric(e1, as(e2, DClass))) )
setMethod("pmax2", c(SClass, SClass),
    function(e1, e2) .sc_val(callGeneric(as(e1, DClass), as(e2, DClass))) )

# pmin2
setMethod("pmin2", c(SClass, "vector"),
    function(e1, e2) .sc_val_e1(callGeneric(as(e1, DClass), e2)) )
setMethod("pmin2", c("vector", SClass),
    function(e1, e2) .sc_val_e2(callGeneric(e1, as(e2, DClass))) )
setMethod("pmin2", c(SClass, SClass),
    function(e1, e2) .sc_val(callGeneric(as(e1, DClass), as(e2, DClass))) )


# scale for each column
x_scale_col <- function(x, center=TRUE, scale=TRUE, with_attr=TRUE)
{
    # check
    x_check(x, "Calling SCArray:::x_scale_col() with %s ...")
    stopifnot(is(x, "SC_GDSMatrix"))
    stopifnot(is.logical(center) || is.numeric(center),
        length(center)==1L || length(center)==ncol(x))
    stopifnot(is.logical(scale) || is.numeric(scale),
        length(scale)==1L || length(scale)==ncol(x))
    # get center and/or scale
    if (isTRUE(center) && isTRUE(scale))
    {
        v <- scColMeanVar(x, na.rm=TRUE)  # calculate mean and var together
        center <- v[,1L]
        scale <- sqrt(v[,2L])
    } else if (isTRUE(center))
    {
        center <- colMeans(x)
    } else if (isTRUE(scale))
    {
        scale <- rowSds(x)
    }
    center <- rep(as.numeric(center), length.out=ncol(x))
    if (isFALSE(scale)) scale <- 1
    scale <- rep(as.numeric(scale), length.out=ncol(x))
    # do
    x <- t(x)
    attr_c <- !isTRUE(all(center==0))
    attr_s <- !isTRUE(all(scale==1))
    if (attr_c) x <- x - center
    if (attr_s)
    {
        inv <- 1/scale
        inv[!is.finite(inv)] <- 0
        x <- x * inv
    }
    x <- t(x)
    if (isTRUE(with_attr))
    {
        if (attr_c) attr(x, "scaled:center") <- center
        if (attr_s) attr(x, "scaled:scale") <- scale
    }
    # output
    x
}

x_scale <- function(x, center=TRUE, scale=TRUE)
{
    x_scale_col(x, center=center, scale=scale)
}

setMethod("scale", SMatrix, x_scale)


#######################################################################
# Generic functions -- scGetFiles()

setGeneric("scGetFiles", function(object, ...) standardGeneric("scGetFiles"))

setMethod("scGetFiles", "SC_GDSArray", function(object, ...) {
    s <- seedApply(object, function(x)
        tryCatch(path(x), error=function(e) NULL)
    )
    unique(unlist(s))
})

setMethod("scGetFiles", "SummarizedExperiment",
    function(object, ...) unique(unlist(lapply(assays(object), scGetFiles))))


#######################################################################
# Generic functions -- scMemory()

setGeneric("scMemory", function(x, ...) x)

setMethod("scMemory", "DelayedArray", function(x, ...)
{
    if (is_sparse(x) && length(dim(x))==2L)
        as(x, "sparseMatrix")
    else
        as.array(x)
})

setMethod("scMemory", "SummarizedExperiment", function(x, ...)
{
    for (i in seq_along(assays(x)))
        assays(x)[[i]] <- scMemory(assays(x)[[i]])
    x
})


#######################################################################
# Generic functions -- scMemory()

scRowAutoGrid <- function(x, force=FALSE, nnzero=NULL)
{
    # check
    stopifnot(is.matrix(x) || is(x, "Matrix") || is(x, "DelayedMatrix"))
    stopifnot(is.logical(force))
    if (!is.null(nnzero))
    {
        stopifnot(is.numeric(nnzero), length(nnzero)==nrow(x))
        if (is.double(nnzero)) nnzero <- as.integer(nnzero)
        z <- nnzero < 0L
        if (anyNA(z)) stop("'nnzero' should have no NA.")
        if (any(z)) stop("'nnzero' should be non-negative.")
    }
    # do
    ans <- rowAutoGrid(x)
    as.sparse <- NA
    is_sp <- is(x, "sparseMatrix")
    if ((is(x, SMatrix) && is_sparse(x)) || is_sp)
    {
        if (isTRUE(force) || is_sp || x_type(x)==1L)
        {
            # x_type(x)==1L (not transposed, column-oriented)
            # the number of non-zeros for each row
            if (is.null(nnzero))
                nnzero <- as.integer(row_nnzero(x, na.counted=TRUE))
            # to use SafeArrayViewport
            bs <- .Call(c_sparse_blocksize, getAutoBlockSize(),
                .Machine$integer.max / ncol(x), nnzero, integer(length(nnzero)))
            v <- ArbitraryArrayGrid(list(cumsum(bs), ncol(x)))
            as.sparse <- isTRUE(force) || length(v)<=length(ans)
            if (as.sparse) ans <- v
        }
    }
    # output
    attr(ans, "as.sparse") <- as.sparse
    ans
}

scColAutoGrid <- function(x, force=FALSE, nnzero=NULL)
{
    # check
    stopifnot(is.matrix(x) || is(x, "Matrix") || is(x, "DelayedMatrix"))
    stopifnot(is.logical(force))
    if (!is.null(nnzero))
    {
        stopifnot(is.numeric(nnzero), length(nnzero)==ncol(x))
        if (is.double(nnzero)) nnzero <- as.integer(nnzero)
        z <- nnzero < 0L
        if (anyNA(z)) stop("'nnzero' should have no NA.")
        if (any(z)) stop("'nnzero' should be non-negative.")
    }
    # do
    ans <- colAutoGrid(x)
    as.sparse <- NA
    is_sp <- is(x, "sparseMatrix")
    if ((is(x, SMatrix) && is_sparse(x)) || is_sp)
    {
        if (isTRUE(force) || is_sp || x_type(x)==2L)
        {
            # x_type(x)==2L (transposed, row-oriented)
            # the number of non-zeros for each column
            if (is.null(nnzero))
                nnzero <- as.integer(col_nnzero(x, na.counted=TRUE))
            # to use SafeArrayViewport
            bs <- .Call(c_sparse_blocksize, getAutoBlockSize(),
                .Machine$integer.max / nrow(x), nnzero, integer(length(nnzero)))
            v <- ArbitraryArrayGrid(list(nrow(x), cumsum(bs)))
            as.sparse <- isTRUE(force) || length(v)<=length(ans)
            if (as.sparse) ans <- v
        }
    }
    # output
    attr(ans, "as.sparse") <- as.sparse
    ans
}


#######################################################################
# Internal functions

.get_num_worker <- function(BPPARAM)
{
    if (is.null(BPPARAM))
        1L
    else
        bpnworkers(BPPARAM)
}

####

.parallel_col_apply <- function(x, BPPARAM, Fun, as.sparse=NA, .flatten=TRUE,
    .progress=NA, ...)
{
    stopifnot(is.null(BPPARAM) || is(BPPARAM, "BiocParallelParam"))
    # progress bar
    stopifnot(is.logical(.progress), length(.progress)==1L)
    if (is.na(.progress)) .progress <- x_progress_verbose()
    # no need dimnames
    if (!is.null(dimnames(x))) dimnames(x) <- NULL
    # split columns
    sp <- scNumSplit(ncol(x), BPPARAM)
    if (length(sp) > 1L)
    {
        x_msg(sprintf("\\=> Distributed to %d processes ...", length(sp)))
        # distribute
        lst <- bplapply(sp, function(s, Fun, x, as.sparse, ...)
        {
            # sub columns
            y <- x[, seq.int(s[1L], s[2L]), drop=FALSE]
            # reduce the sub matrix
            blockApply(y, Fun, grid=colAutoGrid(y), BPPARAM=NULL,
                as.sparse=as.sparse, ...)
        }, BPPARAM=BPPARAM, Fun=Fun, x=x, as.sparse=as.sparse, ...)
        # reduce
        ans <- unlist(lst, recursive=FALSE, use.names=FALSE)
    } else {
        # sequentially
        gd <- colAutoGrid(x)
        if (.progress)
        {
            pb <- txtProgressBar(0L, length(gd), style=3L, width=64L,
                file=stderr())
            on.exit(close(pb))
            ans <- blockApply(x, function(b, .fun, .pb, ...)
                {
                    setTxtProgressBar(.pb, currentBlockId())
                    .fun(b, ...)
                }, grid=gd, as.sparse=as.sparse, BPPARAM=NULL,
                    .fun=Fun, .pb=pb, ...)
        } else {
            ans <- blockApply(x, Fun, grid=gd, as.sparse=as.sparse,
                BPPARAM=NULL, ...)
        }
    }
    # output
    if (.flatten) ans <- unlist(ans, recursive=TRUE, use.names=FALSE)
    ans
}

####

.parallel_col_reduce <- function(x, BPPARAM, Fun, InitFun, ReduceFun,
    as.sparse=NA, .progress=NA, ...)
{
    stopifnot(is.null(BPPARAM) || is(BPPARAM, "BiocParallelParam"))
    # progress bar
    stopifnot(is.logical(.progress), length(.progress)==1L)
    if (is.na(.progress)) .progress <- x_progress_verbose()
    # no need dimnames
    if (!is.null(dimnames(x))) dimnames(x) <- NULL
    # split columns
    sp <- scNumSplit(ncol(x), BPPARAM)
    if (length(sp) > 1L)
    {
        x_msg(sprintf("\\=> Distributed to %d processes ...", length(sp)))
        # distribute
        lst <- bplapply(sp, function(s, Fun, x, as.sparse, ...)
        {
            # sub columns
            y <- x[, seq.int(s[1L], s[2L]), drop=FALSE]
            attr(y, "col_range") <- s
            # initial value
            if (is.function(InitFun))
                init <- InitFun(y, ...)
            else
                init <- InitFun
            # reduce the sub matrix
            blockReduce(Fun, y, init, grid=colAutoGrid(y), as.sparse=as.sparse,
                ...)
        }, BPPARAM=BPPARAM, Fun=Fun, x=x, as.sparse=as.sparse, ...)
        # reduce
        base::Reduce(ReduceFun, lst)
    } else {
        # sequentially
        if (is.function(InitFun))
            init <- InitFun(x, ...)
        else
            init <- InitFun
        gd <- colAutoGrid(x)
        if (.progress)
        {
            pb <- txtProgressBar(0L, length(gd), style=3L, width=64L,
                file=stderr())
            on.exit(close(pb))
            blockReduce(function(b, v, .fun, .pb, ...)
                {
                    setTxtProgressBar(.pb, currentBlockId())
                    .fun(b, v, ...)
                }, x, init, grid=gd, as.sparse=as.sparse, .fun=Fun, .pb=pb, ...)
        } else {
            blockReduce(Fun, x, init, grid=gd, as.sparse=as.sparse, ...)
        }
    }
}

####

.parallel_col_reduce2 <- function(x, BPPARAM, Fun, InitFun, ReduceFun,
    as.sparse=NA, .progress=NA, ...)
{
    stopifnot(is.null(BPPARAM) || is(BPPARAM, "BiocParallelParam"))
    # progress bar
    stopifnot(is.logical(.progress), length(.progress)==1L)
    if (is.na(.progress)) .progress <- x_progress_verbose()
    # no need dimnames
    if (!is.null(dimnames(x))) dimnames(x) <- NULL
    # split columns
    sp <- scNumSplit(ncol(x), BPPARAM)
    if (length(sp) > 1L)
    {
        x_msg(sprintf("\\=> Distributed to %d processes ...", length(sp)))
        # distribute
        lst <- bplapply(sp, function(s, Fun, x, as.sparse, ...)
        {
            # sub columns
            y <- x[, seq.int(s[1L], s[2L]), drop=FALSE]
            attr(y, "col_range") <- s
            # initial value
            if (is.function(InitFun))
                init <- InitFun(y, split=s, ...)
            else
                init <- InitFun
            # reduce the sub matrix
            blockReduce(Fun, y, init, grid=colAutoGrid(y), as.sparse=as.sparse,
                split=s, ...)
        }, BPPARAM=BPPARAM, Fun=Fun, x=x, as.sparse=as.sparse, ...)
        # reduce
        base::Reduce(ReduceFun, lst)
    } else {
        # sequentially
        sp <- c(1L, ncol(x))
        if (is.function(InitFun))
            init <- InitFun(x, split=sp, ...)
        else
            init <- InitFun
        gd <- colAutoGrid(x)
        if (.progress)
        {
            pb <- txtProgressBar(0L, length(gd), style=3L, width=64L,
                file=stderr())
            on.exit(close(pb))
            blockReduce(function(b, v, .fun, .pb, ...)
            {
                setTxtProgressBar(.pb, currentBlockId())
                .fun(b, v, ...)
            }, x, init, grid=gd, as.sparse=as.sparse, .fun=Fun, .pb=pb,
                split=sp, ...)
        } else {
            blockReduce(Fun, x, init, grid=gd, as.sparse=as.sparse, split=sp,
                ...)
        }
    }
}


################

x_verbose <- function()
{
    isTRUE(getOption("SCArray.verbose"))
}

x_progress_verbose <- function()
{
    isTRUE(getOption("SCArray.verbose")) ||
    isTRUE(getOption("SCArray.progress.verbose"))
}

x_progress <- function(grid, verbose=TRUE)
{
    if (verbose && x_progress_verbose())
        txtProgressBar(0L, length(grid), style=3L, width=64L, file=stderr())
    else
        NULL
}

x_msg <- function(msg)
{
    if (x_verbose()) message(msg)
}

x_check <- function(x, msg)
{
    if (!is.null(x))
    {
        if (x_verbose())
        {
            if (grepl("%s", msg, fixed=TRUE))
            {
                s <- class(x)[1L]
                if (x_type(x) == 2L) s <- paste("transposed", s)
                s <- paste0(s, " [", paste(dim(x), collapse="x"), "]")
                msg <- sprintf(msg, s)
            }
            message(msg)
        }
        DelayedArray:::.get_ans_type(x, must.be.numeric=TRUE)
        stopifnot(length(dim(x)) == 2L)
    } else {
        if (x_verbose()) message(msg)
    }
    invisible()
}

x_subset <- function(x, rows, cols)
{
    if (!is.null(rows) && !is.null(cols))
    {
        x <- x[rows, cols, drop = FALSE]
    } else if (!is.null(rows))
    {
        x <- x[rows, , drop = FALSE]
    } else if (!is.null(cols))
    {
        x <- x[, cols, drop = FALSE]
    }
    x
}

x_nperm <- function(x)
{
    ans <- if (is(x, "DelayedAperm")) 1L else 0L
    if (is(x, "DelayedUnaryOp"))
        return((ans + x_nperm(x@seed)) %% 2L)
    if (is(x, "DelayedNaryOp"))
        x <- x@seeds
    if (is.list(x) && !is.array(x))
    {
        v <- vapply(x, x_nperm, 0L, USE.NAMES=FALSE)
        if (isTRUE(all(v == v[1L])))
            ans <- (ans + v[1L]) %% 2L
        else
            ans <- NA_integer_
    }
    ans
}

# Return 1 for SCArraySeed, 2L for transposed SCArraySeed, 3L for others
x_type <- function(x)
{
    # seed(s) should be SCArraySeed or in-memory array
    if (any(!unlist(seedApply(x, function(z)
            is.array(z) || is(z, "Matrix") || is(z, "SCArraySeed")))))
        return(3L)
    # nperm: whether transposed or not
    v <- x_nperm(x) + 1L
    if (is.na(v)) v <- 3L
    v
}

#######################################################################
#
# Package name: SCArray
#
# Description:
#     Large-scale single-cell RNA-seq data manipulation with GDS files
#
# Copyright (C) 2021-2023    Xiuwen Zheng (@AbbVie-ComputationalGenomics)
# License: GPL-3
#


################

.double_nrow  <- function(x, ...) double(nrow(x))
.double_nrow2 <- function(x, ...) double(nrow(x)*2L)
.double_nrow3 <- function(x, ...) double(nrow(x)*3L)
.double_nrow4 <- function(x, ...) double(nrow(x)*4L)


################

.x_row_sums <- function(x, na.rm, useNames=TRUE, BPPARAM=getAutoBPPARAM())
{
    rv <- .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowSums, bk, v, na.rm)
        },
        InitFun = .double_nrow,
        ReduceFun=`+`, na.rm=na.rm)
    if (isTRUE(useNames)) names(rv) <- rownames(x)
    rv
}

.x_col_sums <- function(x, na.rm, useNames=TRUE, BPPARAM=getAutoBPPARAM())
{
    rv <- .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colSums, bk, na.rm)
        },
        na.rm=na.rm)
    if (isTRUE(useNames)) names(rv) <- colnames(x)
    rv
}

x_rowSums <- function(x, na.rm=FALSE, dims=1)
{
    x_check(x, "Calling SCArray:::x_rowSums() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(identical(dims, 1))
    # output
    switch(x_type(x),
        .x_row_sums(x, na.rm),     # 1
        .x_col_sums(t(x), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::rowSums() ...")
            callNextMethod()
        }
    )
}

x_colSums <- function(x, na.rm=FALSE, dims=1)
{
    x_check(x, "Calling SCArray:::x_colSums() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(identical(dims, 1))
    # output
    switch(x_type(x),
        .x_col_sums(x, na.rm),     # 1
        .x_row_sums(t(x), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::colSums() ...")
            callNextMethod()
        }
    )
}

x_rowSums2 <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowSums2() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            .x_row_sums(x, na.rm, useNames, ...)
        else
            .x_col_sums(t(x), na.rm, useNames, ...)
    } else {
        x_msg("Calling DelayedMatrixStats::rowSums2() ...")
        callNextMethod()
    }
}

x_colSums2 <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colSums2() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            .x_col_sums(x, na.rm, useNames, ...)
        else
            .x_row_sums(t(x), na.rm, useNames, ...)
    } else {
        x_msg("Calling DelayedMatrixStats::colSums2() ...")
        callNextMethod()
    }
}

setMethod("rowSums", SMatrix, x_rowSums)
setMethod("colSums", SMatrix, x_colSums)
setMethod("rowSums2", SMatrix, x_rowSums2)
setMethod("colSums2", SMatrix, x_colSums2)


################

x_rowLogSumExps <- function(lx, rows=NULL, cols=NULL, na.rm=FALSE, ...,
    useNames=NA)
{
    x_check(lx, "Calling SCArray:::x_rowLogSumExps() with %s ...")
    log(x_rowSums2(exp(lx), rows=rows, cols=cols, na.rm=na.rm, ...,
        useNames=useNames))
}

x_colLogSumExps <- function(lx, rows=NULL, cols=NULL, na.rm=FALSE, ...,
    useNames=NA)
{
    x_check(lx, "Calling SCArray:::x_colLogSumExps() with %s ...")
    log(x_colSums2(exp(lx), rows=rows, cols=cols, na.rm=na.rm, ...,
        useNames=useNames))
}

setMethod("rowLogSumExps", SMatrix, x_rowLogSumExps)
setMethod("colLogSumExps", SMatrix, x_colLogSumExps)


################

# row grouping, ii starts from ZERO
.x_row_sum_grp <- function(x, ii, n_grp, na.rm, BPPARAM=getAutoBPPARAM())
{
    # block read
    lst <- .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, ii, n_grp, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_row_sum_grp, bk, ii, n_grp, na.rm)
        },
        .flatten=FALSE, ii=ii, n_grp=n_grp, na.rm=na.rm)
    # merge
    do.call(cbind, lst)
}

# column grouping, ii starts from ZERO
.x_col_sum_grp <- function(x, ii, n_grp, na.rm, BPPARAM=getAutoBPPARAM())
{
    # block read
    blockReduce(function(bk, v, ii, n_grp, na.rm)
    {
        st <- start(currentViewport())
        # C++ code doesn't handle SVT_SparseArray objects
        if (is(bk, "SVT_SparseArray"))
            bk <- as(bk, "COO_SparseArray")
        .Call(c_col_sum_grp, bk, v, ii, st, n_grp, na.rm)
    }, x, matrix(0, nrow(x), n_grp), grid=colAutoGrid(x), as.sparse=NA,
        ii=ii, n_grp=n_grp, na.rm=na.rm)
}

x_rowsum_grp <- function(x, group, reorder=TRUE, na.rm=FALSE, ...)
{
    # check
    x_check(x, "Calling SCArray:::x_rowsum_grp() with %s ...")
    stopifnot(length(group) == nrow(x))
    stopifnot(is.logical(reorder), length(reorder)==1L)
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    # grouping
    grp <- unique(group)
    grp <- grp[!is.na(grp)]
    if (length(grp) == 0L) stop("No group value!")
    if (isTRUE(reorder)) grp <- sort(grp)
    ii <- match(group, grp) - 1L  # start from ZERO
    # output
    if (x_type(x) == 2L)
    {
        ans <- .x_col_sum_grp(t(x), ii, length(grp), na.rm, ...)
        ans <- t(ans)
    } else {
        ans <- .x_row_sum_grp(x, ii, length(grp), na.rm, ...)
    }
    colnames(ans) <- colnames(x)
    rownames(ans) <- grp
    ans
}

x_colsum_grp <- function(x, group, reorder=TRUE, na.rm=FALSE, ...)
{
    # check
    x_check(x, "Calling SCArray:::x_colsum_grp() with %s ...")
    stopifnot(length(group) == ncol(x))
    stopifnot(is.logical(reorder), length(reorder)==1L)
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    # grouping
    grp <- unique(group)
    grp <- grp[!is.na(grp)]
    if (length(grp) == 0L) stop("No group value!")
    if (isTRUE(reorder)) grp <- sort(grp)
    ii <- match(group, grp) - 1L  # start from ZERO
    # output
    if (x_type(x) == 2L)
    {
        ans <- .x_row_sum_grp(t(x), ii, length(grp), na.rm, ...)
        ans <- t(ans)
    } else {
        ans <- .x_col_sum_grp(x, ii, length(grp), na.rm, ...)
    }
    rownames(ans) <- rownames(x)
    colnames(ans) <- grp
    ans
}

setMethod("rowsum", SMatrix, x_rowsum_grp)
setMethod("colsum", SMatrix, x_colsum_grp)


################

.x_row_prods <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowProds, bk, v, na.rm)
        },
        InitFun = function(x, ...) rep(1, nrow(x)),
        ReduceFun=`*`, as.sparse=FALSE, na.rm=na.rm)
}

.x_col_prods <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colProds, bk, na.rm)
        },
        as.sparse=FALSE, na.rm=na.rm)
}

x_rowProds <- function(x, rows=NULL, cols=NULL, na.rm=FALSE,
    method=c("direct", "expSumLog"), ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowProds() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    method <- match.arg(method)
    if (method == "direct")
    {
        if (x_type(x) == 1L)
        {
            x <- x_subset(x, rows, cols)
            v <- .x_row_prods(x, na.rm, ...)
            if (isTRUE(useNames)) names(v) <- rownames(x)
            v  # output
        } else {
            x_msg("Calling DelayedMatrixStats::rowProds() ...")
            callNextMethod()
        }
    } else {
        x <- x_subset(x, rows, cols)
        nz <- rowSums(x==0L, na.rm=na.rm)
        nl <- rowSums(x<0L,  na.rm=na.rm)
        v <- exp(rowSums(log(abs(x)), na.rm=na.rm))
        i <- which(nl %% 2L == 1L)
        if (length(i)) v[i] <- -v[i]
        i <- which(nz > 0L)
        if (length(i)) v[i] <- 0
        if (isTRUE(useNames)) names(v) <- rownames(x)
        v
    }
}

x_colProds <- function(x, rows=NULL, cols=NULL, na.rm=FALSE,
    method=c("direct", "expSumLog"), ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colProds() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    method <- match.arg(method)
    if (method == "direct")
    {
        if (x_type(x) != 2L)
        {
            x_msg("Calling DelayedMatrixStats::colProds() ...")
            callNextMethod()
        } else {
            x_msg("Calling DelayedArray::.x_row_prods() ...")
            x <- x_subset(x, rows, cols)
            v <- .x_row_prods(t(x), na.rm, ...)
            if (isTRUE(useNames)) names(v) <- colnames(x)
            v  # output
        }
    } else {
        x <- x_subset(x, rows, cols)
        nz <- colSums(x==0L, na.rm=na.rm)
        nl <- colSums(x<0L,  na.rm=na.rm)
        v <- exp(colSums(log(abs(x)), na.rm=na.rm))
        i <- which(nl %% 2L == 1L)
        if (length(i)) v[i] <- -v[i]
        i <- which(nz > 0L)
        if (length(i)) v[i] <- 0
        if (isTRUE(useNames)) names(v) <- colnames(x)
        v
    }
}

setMethod("rowProds", SMatrix, x_rowProds)
setMethod("colProds", SMatrix, x_colProds)


################

.x_row_means <- function(x, na.rm, useNames=TRUE, BPPARAM=getAutoBPPARAM())
{
    rv <- .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowMeans, bk, v, na.rm)
        },
        InitFun = .double_nrow2,
        ReduceFun=`+`, na.rm=na.rm)
    # finally
    rv <- .Call(c_rowMeans_final, rv)
    if (isTRUE(useNames)) names(rv) <- rownames(x)
    rv
}

.x_col_means <- function(x, na.rm, useNames=TRUE, BPPARAM=getAutoBPPARAM())
{
    rv <- .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colMeans, bk, na.rm)
        },
        na.rm=na.rm)
    if (isTRUE(useNames)) names(rv) <- colnames(x)
    rv
}

x_rowMeans <- function(x, na.rm=FALSE, dims=1)
{
    x_check(x, "Calling SCArray:::x_rowMeans() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(identical(dims, 1))
    # output
    switch(x_type(x),
        .x_row_means(x, na.rm),     # 1
        .x_col_means(t(x), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::rowMeans() ...")
            callNextMethod()
        }
    )
}

x_colMeans <- function(x, na.rm=FALSE, dims=1)
{
    x_check(x, "Calling SCArray:::x_colMeans() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(identical(dims, 1))
    switch(x_type(x),
        .x_col_means(x, na.rm),     # 1
        .x_row_means(t(x), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::colMeans() ...")
            callNextMethod()
        }
    )
}

x_rowMeans2 <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowMeans2() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            .x_row_means(x, na.rm, useNames, ...)
        else
            .x_col_means(t(x), na.rm, useNames, ...)
    } else {
        x_msg("Calling DelayedMatrixStats::rowMeans2() ...")
        callNextMethod()
    }
}

x_colMeans2 <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colMeans2() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            .x_col_means(x, na.rm, useNames, ...)
        else
            .x_row_means(t(x), na.rm, useNames, ...)
    } else {
        x_msg("Calling DelayedMatrixStats::colMeans2() ...")
        callNextMethod()
    }
}

setMethod("rowMeans", SMatrix, x_rowMeans)
setMethod("colMeans", SMatrix, x_colMeans)
setMethod("rowMeans2", SMatrix, x_rowMeans2)
setMethod("colMeans2", SMatrix, x_colMeans2)


################

.x_row_w_means <- function(x, w, na.rm, BPPARAM=getAutoBPPARAM())
{
    # initialize
    stopifnot(is.numeric(w), length(w)==ncol(x))
    if (is.integer(w)) w <- as.double(w)
    # block read
    rv <- .parallel_col_reduce2(x, BPPARAM,
        Fun = function(bk, v, split, w, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowWMeans, bk, v, split, w,
                start(currentViewport(parent.frame(2L))), na.rm)
        },
        InitFun = .double_nrow2,
        ReduceFun=`+`, w=w, na.rm=na.rm)
    # finally
    .Call(c_rowWMeans_final, rv)
}

.x_col_w_means <- function(x, w, na.rm, BPPARAM=getAutoBPPARAM())
{
    stopifnot(is.numeric(w), length(w)==nrow(x))
    if (is.integer(w)) w <- as.double(w)
    # block read
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, w, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colMeans, bk, w, na.rm)
        },
        w=w, na.rm=na.rm)
}

x_rowWeightedMeans <- function(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE,
    ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowWeightedMeans() with %s ...")
    if (is.null(w))
        return(x_rowMeans2(x, rows, cols, na.rm, ..., useNames=useNames))
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_row_w_means(x, w, na.rm, ...)
        else
            v <- .x_col_w_means(t(x), w, na.rm, ...)
        if (isTRUE(useNames)) names(v) <- rownames(x)
        v
    } else {
        x_msg("Calling DelayedMatrixStats::rowWeightedMeans() ...")
        callNextMethod()
    }
}

x_colWeightedMeans <- function(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE,
    ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colWeightedMeans() with %s ...")
    if (is.null(w))
        return(x_colMeans2(x, rows, cols, na.rm, ..., useNames=useNames))
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_col_w_means(x, w, na.rm, ...)
        else
            v <- .x_row_w_means(t(x), w, na.rm, ...)
        if (isTRUE(useNames)) names(v) <- colnames(x)
        v
    } else {
        x_msg("Calling DelayedMatrixStats::colWeightedMeans() ...")
        callNextMethod()
    }
}

setMethod("rowWeightedMeans", SMatrix, x_rowWeightedMeans)
setMethod("colWeightedMeans", SMatrix, x_colWeightedMeans)


################

.x_row_vars <- function(x, na.rm, center, BPPARAM=getAutoBPPARAM())
{
    # check
    if (length(center))
    {
        if (length(center)==1L) center <- rep(center, nrow(x))
        stopifnot(nrow(x) == length(center))
        if (is.integer(center)) center <- as.double(center)
    }
    # block read
    rv <- .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm, center)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowVars, bk, v, na.rm, center)
        },
        InitFun = .double_nrow3,
        ReduceFun=`+`, na.rm=na.rm, center=center)
    # finally
    .Call(c_rowVars_final, rv, center)
}

.x_col_vars <- function(x, na.rm, center, BPPARAM=getAutoBPPARAM())
{
    # check
    if (length(center))
    {
        if (length(center)==1L) center <- rep(center, ncol(x))
        stopifnot(ncol(x) == length(center))
        if (is.integer(center)) center <- as.double(center)
    }
    # block read
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm, center)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colVars, bk, na.rm, center)
        },
        na.rm=na.rm, center=center)
}

x_rowVars <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ...,
    useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowVars() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(is.null(center) || is.numeric(center))
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_row_vars(x, na.rm, center, ...)
        else
            v <- .x_col_vars(t(x), na.rm, center, ...)
        if (isTRUE(useNames)) names(v) <- rownames(x)
        v
    } else {
        x_msg("Calling DelayedMatrixStats::rowVars() ...")
        callNextMethod()
    }
}

x_colVars <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ...,
    useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colVars() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(is.null(center) || is.numeric(center))
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_col_vars(x, na.rm, center, ...)
        else
            v <- .x_row_vars(t(x), na.rm, center, ...)
        if (isTRUE(useNames)) names(v) <- colnames(x)
        v
    } else {
        x_msg("Calling DelayedMatrixStats::colVars() ...")
        callNextMethod()
    }
}

setMethod("rowVars", SMatrix, x_rowVars)
setMethod("colVars", SMatrix, x_colVars)


################

x_rowSds <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ...,
    useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowSds() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(is.null(center) || is.numeric(center))
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_row_vars(x, na.rm, center, ...)
        else
            v <- .x_col_vars(t(x), na.rm, center, ...)
        v <- sqrt(v)
        if (isTRUE(useNames)) names(v) <- rownames(x)
        v
    } else {
        x_msg("Calling DelayedMatrixStats::rowSds() ...")
        callNextMethod()
    }
}

x_colSds <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ...,
    useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colSds() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    stopifnot(is.null(center) || is.numeric(center))
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_col_vars(x, na.rm, center, ...)
        else
            v <- .x_row_vars(t(x), na.rm, center, ...)
        v <- sqrt(v)
        if (isTRUE(useNames)) names(v) <- colnames(x)
        v
    } else {
        x_msg("Calling DelayedMatrixStats::colSds() ...")
        callNextMethod()
    }
}

setMethod("rowSds", SMatrix, x_rowSds)
setMethod("colSds", SMatrix, x_colSds)


################

.x_row_w_vars <- function(x, w, na.rm, BPPARAM=getAutoBPPARAM())
{
    # initialize
    stopifnot(is.numeric(w), length(w)==ncol(x))
    if (is.integer(w)) w <- as.double(w)
    # block read
    rv <- .parallel_col_reduce2(x, BPPARAM,
        Fun = function(bk, v, split, w, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowWVars, bk, v, split, w,
                start(currentViewport(parent.frame(2L))), na.rm)
        },
        InitFun = .double_nrow4,
        ReduceFun=`+`, w=w, na.rm=na.rm)
    # finally
    .Call(c_rowWVars_final, rv)
}

.x_col_w_vars <- function(x, w, na.rm, BPPARAM=getAutoBPPARAM())
{
    # initialize
    stopifnot(is.numeric(w), length(w)==nrow(x))
    if (is.integer(w)) w <- as.double(w)
    # block read
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, w, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colWVars, bk, w, na.rm)
        },
        w=w, na.rm=na.rm)
}

x_rowWeightedVars <- function(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE,
    ..., useNames=NA)
{
    if (is.null(w))
    {
        x_rowVars(x, rows, cols, na.rm, ..., useNames=useNames)
    } else {
        x_check(x, "Calling SCArray:::x_rowWeightedVars() with %s ...")
        stopifnot(is.logical(na.rm), length(na.rm)==1L)
        k <- x_type(x)
        if (k < 3L)
        {
            x <- x_subset(x, rows, cols)
            if (k == 1L)
                v <- .x_row_w_vars(x, w, na.rm, ...)
            else
                v <- .x_col_w_vars(t(x), w, na.rm, ...)
            if (isTRUE(useNames)) names(v) <- rownames(x)
            v
        } else {
            x_msg("Calling DelayedMatrixStats::rowWeightedVars() ...")
            callNextMethod()
        }
    }
}

x_colWeightedVars <- function(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE,
    ..., useNames=NA)
{
    if (is.null(w))
    {
        x_colVars(x, rows, cols, na.rm, ..., useNames=useNames)
    } else {
        x_check(x, "Calling SCArray:::x_colWeightedVars() with %s ...")
        stopifnot(is.logical(na.rm), length(na.rm)==1L)
        k <- x_type(x)
        if (k < 3L)
        {
            x <- x_subset(x, rows, cols)
            if (k == 1L)
                v <- .x_col_w_vars(x, w, na.rm, ...)
            else
                v <- .x_row_w_vars(t(x), w, na.rm, ...)
            if (isTRUE(useNames)) names(v) <- colnames(x)
            v
        } else {
            x_msg("Calling DelayedMatrixStats::colWeightedVars() ...")
            callNextMethod()
        }
    }
}

setMethod("rowWeightedVars", SMatrix, x_rowWeightedVars)
setMethod("colWeightedVars", SMatrix, x_colWeightedVars)


################

x_rowWeightedSds <- function(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE,
    ..., useNames=NA)
{
    if (is.null(w))
    {
        x_rowSds(x, rows, cols, na.rm, ..., useNames=useNames)
    } else {
        x_check(x, "Calling SCArray:::x_rowWeightedSds() with %s ...")
        stopifnot(is.logical(na.rm), length(na.rm)==1L)
        k <- x_type(x)
        if (k < 3L)
        {
            x <- x_subset(x, rows, cols)
            if (k == 1L)
                v <- .x_row_w_vars(x, w, na.rm, ...)
            else
                v <- .x_col_w_vars(t(x), w, na.rm, ...)
            v <- sqrt(v)
            if (isTRUE(useNames)) names(v) <- rownames(x)
            v
        } else {
            x_msg("Calling DelayedMatrixStats::rowWeightedSds() ...")
            callNextMethod()
        }
    }
}

x_colWeightedSds <- function(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE,
    ..., useNames = NA)
{
    if (is.null(w))
    {
        x_colSds(x, rows, cols, na.rm, ..., useNames=useNames)
    } else {
        x_check(x, "Calling SCArray:::x_colWeightedSds() with %s ...")
        stopifnot(is.numeric(w), length(w)==nrow(x))
        stopifnot(is.logical(na.rm), length(na.rm)==1L)
        k <- x_type(x)
        if (k < 3L)
        {
            x <- x_subset(x, rows, cols)
            if (k == 1L)
                v <- .x_col_w_vars(x, w, na.rm, ...)
            else
                v <- .x_row_w_vars(t(x), w, na.rm, ...)
            v <- sqrt(v)
            if (isTRUE(useNames)) names(v) <- colnames(x)
            v
        } else {
            x_msg("Calling DelayedMatrixStats::colWeightedSds() ...")
            callNextMethod()
        }
    }
}

setMethod("rowWeightedSds", SMatrix, x_rowWeightedSds)
setMethod("colWeightedSds", SMatrix, x_colWeightedSds)


################

.x_row_mins <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowMins, bk, v, na.rm)
        },
        InitFun = function(x, ...) rep(Inf, nrow(x)),
        ReduceFun=base::pmin, na.rm=na.rm)
}

.x_col_mins <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colMins, bk, na.rm)
        },
        na.rm=na.rm)
}

x_rowMins <- function(x, rows=NULL, cols=NULL, na.rm=FALSE)
{
    x_check(x, "Calling SCArray:::x_rowMins() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    switch(x_type(x),
        .x_row_mins(x_subset(x, rows, cols), na.rm),     # 1
        .x_col_mins(t(x_subset(x, rows, cols)), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::rowMins() ...")
            callNextMethod()
        })
}

x_colMins <- function(x, rows=NULL, cols=NULL, na.rm=FALSE)
{
    x_check(x, "Calling SCArray:::x_colMins() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    switch(x_type(x),
        .x_col_mins(x_subset(x, rows, cols), na.rm),     # 1
        .x_row_mins(t(x_subset(x, rows, cols)), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::colMins() ...")
            callNextMethod()
        })
}

setMethod("rowMins", SMatrix, x_rowMins)
setMethod("colMins", SMatrix, x_colMins)


################

.x_row_maxs <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowMaxs, bk, v, na.rm)
        },
        InitFun = function(x, ...) rep(-Inf, nrow(x)),
        ReduceFun=base::pmax, na.rm=na.rm)
}

.x_col_maxs <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colMaxs, bk, na.rm)
        },
        na.rm=na.rm)
}

x_rowMaxs <- function(x, rows=NULL, cols=NULL, na.rm=FALSE)
{
    x_check(x, "Calling SCArray:::x_rowMaxs() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    switch(x_type(x),
        .x_row_maxs(x_subset(x, rows, cols), na.rm),     # 1
        .x_col_maxs(t(x_subset(x, rows, cols)), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::rowMaxs() ...")
            callNextMethod()
        })
}

x_colMaxs <- function(x, rows=NULL, cols=NULL, na.rm=FALSE)
{
    x_check(x, "Calling SCArray:::x_colMaxs() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    switch(x_type(x),
        .x_col_maxs(x_subset(x, rows, cols), na.rm),     # 1
        .x_row_maxs(t(x_subset(x, rows, cols)), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::colMaxs() ...")
            callNextMethod()
        })
}

setMethod("rowMaxs", SMatrix, x_rowMaxs)
setMethod("colMaxs", SMatrix, x_colMaxs)


################

.x_row_ranges <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowRanges, bk, v, na.rm)
        },
        InitFun = function(x, ...)
            t(matrix(c(Inf, -Inf), nrow=2L, ncol=nrow(x))),
        ReduceFun = function(v1, v2)
            cbind(base::pmin(v1[,1L], v2[,1L]), base::pmax(v1[,2L], v2[,2L])),
        na.rm=na.rm)
}

.x_col_ranges <- function(x, na.rm, BPPARAM=getAutoBPPARAM())
{
    lst <- .parallel_col_apply(x, BPPARAM,
        Fun = function(bk, na.rm)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colRanges, bk, na.rm)
        },
        .flatten=FALSE, na.rm=na.rm)
    do.call(rbind, lst)
}

x_rowRanges <- function(x, rows=NULL, cols=NULL, na.rm=FALSE)
{
    x_check(x, "Calling SCArray:::x_rowRanges() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    switch(x_type(x),
        .x_row_ranges(x_subset(x, rows, cols), na.rm),     # 1
        .x_col_ranges(t(x_subset(x, rows, cols)), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::rowRanges() ...")
            callNextMethod()
        })
}

x_colRanges <- function(x, rows=NULL, cols=NULL, na.rm=FALSE)
{
    x_check(x, "Calling SCArray:::x_colRanges() with %s ...")
    stopifnot(is.logical(na.rm), length(na.rm)==1L)
    switch(x_type(x),
        .x_col_ranges(x_subset(x, rows, cols), na.rm),     # 1
        .x_row_ranges(t(x_subset(x, rows, cols)), na.rm),  # 2
        {   # 3
            x_msg("Calling DelayedArray::colRanges() ...")
            callNextMethod()
        })
}

setMethod("rowRanges", SMatrix, x_rowRanges)
setMethod("colRanges", SMatrix, x_colRanges)


################

.x_row_anyNA <- function(x, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_reduce(x, BPPARAM,
        Fun = function(bk, v)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_row_anyNA, bk, v)
        },
        InitFun = function(x, ...) logical(nrow(x)),
        ReduceFun=`|`)
}

.x_col_anyNA <- function(x, BPPARAM=getAutoBPPARAM())
{
    .parallel_col_apply(x, BPPARAM,
        Fun = function(bk)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_col_anyNA, bk)
        })
}

x_row_anyNA <- function(x, rows=NULL, cols=NULL, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_row_anyNA() with %s ...")
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_row_anyNA(x, ...)
        else
            v <- .x_col_anyNA(t(x), ...)
        if (isTRUE(useNames)) names(v) <- rownames(x)
        v
    } else {  # 3
        x_msg("Calling DelayedMatrixStats::rowAnyNAs() ...")
        callNextMethod()
    }
}

x_col_anyNA <- function(x, rows=NULL, cols=NULL, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_col_anyNA() with %s ...")
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, cols)
        if (k == 1L)
            v <- .x_col_anyNA(x, ...)
        else
            v <- .x_row_anyNA(t(x), ...)
        if (isTRUE(useNames)) names(v) <- colnames(x)
        v
    } else {  # 3
        x_msg("Calling DelayedMatrixStats::colAnyNAs() ...")
        callNextMethod()
    }
}

setMethod("rowAnyNAs", SMatrix, x_row_anyNA)
setMethod("colAnyNAs", SMatrix, x_col_anyNA)


################

.x_row_collapse <- function(x, idx)
{
    if (is.double(idx)) idx <- as.integer(idx)
    ii <- unique(sort(idx))  # NA is removed
    idx <- match(idx, ii)
    x <- x[, ii, drop=FALSE]
    # init
    .Call(c_rowCollapse_init, idx, dim(x))
    on.exit(.Call(c_rowCollapse_done))
    init_val <- rep(NA, nrow(x))
    storage.mode(init_val) <- type(x)
    # block read
    blockReduce(function(bk, v)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_rowCollapse, bk, v)
        },
        x, init=init_val, grid=colAutoGrid(x))
}

.x_col_collapse <- function(x, idx)
{
    if (is.double(idx)) idx <- as.integer(idx)
    ii <- unique(sort(idx))  # NA is removed
    idx <- match(idx, ii)
    x <- x[ii, , drop=FALSE]
    # init
    .Call(c_colCollapse_init, idx)
    # block read
    blockReduce(function(bk, v)
        {
            # C++ code doesn't handle SVT_SparseArray objects
            if (is(bk, "SVT_SparseArray"))
                bk <- as(bk, "COO_SparseArray")
            .Call(c_colCollapse, bk, v)
        },
        x, init=vector(type(x), ncol(x)), grid=colAutoGrid(x))
}

x_rowCollapse <- function(x, idxs, rows=NULL, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowCollapse() with %s ...")
    stopifnot(is.numeric(idxs), length(idxs) > 0L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, rows, NULL)
        if (k == 1L)
            v <- .x_row_collapse(x, idxs)
        else
            v <- .x_col_collapse(t(x), idxs)
        if (isTRUE(useNames)) names(v) <- rownames(x)
        v
    } else {  # 3
        x_msg("Calling DelayedMatrixStats::rowCollapse() ...")
        callNextMethod()
    }
}

x_colCollapse <- function(x, idxs, cols=NULL, ..., useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colCollapse() with %s ...")
    stopifnot(is.numeric(idxs), length(idxs) > 0L)
    k <- x_type(x)
    if (k < 3L)
    {
        x <- x_subset(x, NULL, cols)
        if (k == 1L)
            v <- .x_col_collapse(x, idxs)
        else
            v <- .x_row_collapse(t(x), idxs)
        if (isTRUE(useNames)) names(v) <- colnames(x)
        v
    } else {  # 3
        x_msg("Calling DelayedMatrixStats::colCollapse() ...")
        callNextMethod()
    }
}

setMethod("rowCollapse", SMatrix, x_rowCollapse)
setMethod("colCollapse", SMatrix, x_colCollapse)


################

x_rowDiffs <- function(x, rows=NULL, cols=NULL, lag=1L, differences=1L, ...,
    useNames=NA)
{
    x_check(x, "Calling SCArray:::x_rowDiffs() with %s ...")
    # check
    stopifnot(is.numeric(lag), length(lag)==1L)
    stopifnot(is.numeric(differences), length(differences)==1L)
    lag <- as.integer(lag)
    if (anyNA(lag) || lag<1L)
        stop("'lag' must be a positive integer.")
    differences <- as.integer(differences)
    if (anyNA(differences) || differences<1L)
        stop("'differences' must be a positive integer.")
    # subset
    x <- x_subset(x, rows, cols)
    if (lag >= ncol(x)) stop("'lag' should be less than ncol(x).")
    nm_r <- rownames(x)
    nm_c <- colnames(x)
    if (!is.null(nm_r)) rownames(x) <- NULL
    if (!is.null(nm_c)) colnames(x) <- NULL
    # diff
    ndiff <- differences
    while (ndiff > 0L)
    {
        if (ncol(x) <= lag)
            stop("'differences' is too large.")
        i <- seq.int(1L, ncol(x)-lag)
        x <- x[, i+lag, drop=FALSE] - x[, i, drop=FALSE]
        ndiff <- ndiff - 1L
    }
    # row & column names
    if (isTRUE(useNames))
    {
        if (!is.null(nm_r)) rownames(x) <- nm_r
        if (!is.null(nm_c))
        {
            while (differences > 0L)
            {
                nm_c <- nm_c[seq.int(1L+lag, length(nm_c))]
                differences <- differences - 1L
            }
            colnames(x) <- nm_c
        }
    }
    # output
    x
}

x_colDiffs <- function(x, rows=NULL, cols=NULL, lag=1L, differences=1L, ...,
    useNames=NA)
{
    x_check(x, "Calling SCArray:::x_colDiffs() with %s ...")
    # check
    stopifnot(is.numeric(lag), length(lag)==1L)
    stopifnot(is.numeric(differences), length(differences)==1L)
    lag <- as.integer(lag)
    if (anyNA(lag) || lag<1L)
        stop("'lag' must be a positive integer.")
    differences <- as.integer(differences)
    if (anyNA(differences) || differences<1L)
        stop("'differences' must be a positive integer.")
    # subset
    x <- x_subset(x, rows, cols)
    if (lag >= nrow(x)) stop("'lag' should be less than nrow(x).")
    nm_r <- rownames(x)
    nm_c <- colnames(x)
    if (!is.null(nm_r)) rownames(x) <- NULL
    if (!is.null(nm_c)) colnames(x) <- NULL
    # diff
    ndiff <- differences
    while (ndiff > 0L)
    {
        if (nrow(x) <= lag)
            stop("'differences' is too large.")
        i <- seq.int(1L, nrow(x)-lag)
        x <- x[i+lag, , drop=FALSE] - x[i, , drop=FALSE]
        ndiff <- ndiff - 1L
    }
    # row & column names
    if (isTRUE(useNames))
    {
        if (!is.null(nm_c)) colnames(x) <- nm_c
        if (!is.null(nm_r))
        {
            while (differences > 0L)
            {
                nm_r <- nm_r[seq.int(1L+lag, length(nm_r))]
                differences <- differences - 1L
            }
            rownames(x) <- nm_r
        }
    }
    # output
    x
}

setMethod("rowDiffs", SMatrix, x_rowDiffs)
setMethod("colDiffs", SMatrix, x_colDiffs)


################

# Disable is_sparse,
#   since "NOT IMPLEMENTED YET!" in extract_sparse_array() in DelayedArray
#   will be removed when implemented!
setMethod("is_sparse", "DelayedNaryIsoOp", function(x) FALSE)


x_rowSdDiffs <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, diff=1L,
    trim=0, ..., useNames=NA)
{
    stopifnot(is.numeric(trim), length(trim)==1L, 0<=trim, trim<=0.5)
    x <- rowDiffs(x, rows=rows, cols=cols, differences=diff, useNames=useNames)
    if (trim != 0) warning("'trim' is ignored.", immediate.=TRUE)
    rowSds(x, na.rm=na.rm, useNames=useNames)
}

x_colSdDiffs <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, diff=1L,
    trim=0, ..., useNames=NA)
{
    stopifnot(is.numeric(trim), length(trim)==1L, 0<=trim, trim<=0.5)
    x <- colDiffs(x, rows=rows, cols=cols, differences=diff, useNames=useNames)
    if (trim != 0) warning("'trim' is ignored.", immediate.=TRUE)
    colSds(x, na.rm=na.rm, useNames=useNames)
}

x_rowVarDiffs <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, diff=1L,
    trim=0, ..., useNames=NA)
{
    stopifnot(is.numeric(trim), length(trim)==1L, 0<=trim, trim<=0.5)
    x <- rowDiffs(x, rows=rows, cols=cols, differences=diff, useNames=useNames)
    if (trim != 0) warning("'trim' is ignored.", immediate.=TRUE)
    rowVars(x, na.rm=na.rm, useNames=useNames)
}

x_colVarDiffs <- function(x, rows=NULL, cols=NULL, na.rm=FALSE, diff=1L,
    trim=0, ..., useNames=NA)
{
    stopifnot(is.numeric(trim), length(trim)==1L, 0<=trim, trim<=0.5)
    x <- colDiffs(x, rows=rows, cols=cols, differences=diff, useNames=useNames)
    if (trim != 0) warning("'trim' is ignored.", immediate.=TRUE)
    colVars(x, na.rm=na.rm, useNames=useNames)
}

setMethod("rowSdDiffs", SMatrix, x_rowSdDiffs)
setMethod("colSdDiffs", SMatrix, x_colSdDiffs)
setMethod("rowVarDiffs", SMatrix, x_rowVarDiffs)
setMethod("colVarDiffs", SMatrix, x_colVarDiffs)


################

x_rowAvgsPerColSet <- function(X, W=NULL, rows=NULL, S, FUN=rowMeans, ...,
    na.rm=NA, tFUN=FALSE)
{
    # check
    stopifnot(is.matrix(S))
    if (.is_matrix(W))
    {
        if (!identical(dim(X), dim(W)))
            stop("'W' should have the same dimensions as 'X'.")
        X <- X * W
    } else if (!is.null(W))
        stop("'W' should be NULL, or a matrix-like object.")
    FUN <- match.fun(FUN)
    stopifnot(is.logical(tFUN), length(tFUN)==1L, !is.na(tFUN))
    # subset
    if (!is.null(rows)) X <- x_subset(X, rows, NULL)
    # for-loop
    rv <- lapply(seq_len(ncol(S)), FUN=function(i, ...)
        {
            x <- X[, S[,i], drop=FALSE]
            if (tFUN) x <- t(x)
            FUN(x, na.rm=na.rm, ...)
        }, ...)
    rv <- do.call(cbind, rv)
    if (!is.null(colnames(S)) && NCOL(rv)==ncol(S))
        colnames(rv) <- colnames(S)
    # output
    rv
}

x_colAvgsPerRowSet <- function(X, W=NULL, cols=NULL, S, FUN=colMeans, ...,
    na.rm=NA, tFUN=FALSE)
{
    # check
    stopifnot(is.matrix(S))
    if (.is_matrix(W))
    {
        if (!identical(dim(X), dim(W)))
            stop("'W' should have the same dimensions as 'X'.")
        X <- X * W
    } else if (!is.null(W))
        stop("'W' should be NULL, or a matrix-like object.")
    FUN <- match.fun(FUN)
    stopifnot(is.logical(tFUN), length(tFUN)==1L, !is.na(tFUN))
    # subset
    if (!is.null(cols)) X <- x_subset(X, NULL, cols)
    # for-loop
    rv <- lapply(seq_len(ncol(S)), FUN=function(i, ...)
        {
            x <- X[S[,i], , drop=FALSE]
            if (tFUN) x <- t(x)
            FUN(x, na.rm=na.rm, ...)
        }, ...)
    rv <- do.call(rbind, rv)
    if (!is.null(colnames(S)) && NROW(rv)==ncol(S))
        rownames(rv) <- colnames(S)
    # output
    rv
}

setMethod("rowAvgsPerColSet", SMatrix, x_rowAvgsPerColSet)
setMethod("colAvgsPerRowSet", SMatrix, x_colAvgsPerRowSet)

---
title: "SCArray -- Large-scale single-cell omics data manipulation with GDS files"
author:
    - Dr. Xiuwen Zheng
    - Genomics Research Center, AbbVie
date: "Aug, 2021"
output: slidy_presentation
vignette: >
    %\VignetteIndexEntry{Overview}
    %\VignetteDepends{gdsfmt}
    %\VignetteKeywords{SingleCell, RNA-seq}
    %\VignetteEngine{knitr::rmarkdown}
---

## Introduction

- Single-cell technology development
    * larger and larger numbers of cells assayed per experiment
    * the scalability leveraging on-disk data processing (avoid "out-of-memory")
- Genomic Data Structure (GDS) files
    * an alternative to HDF5 & TileDB
    * hierarchical structure to store array-oriented data sets
    * compress & decompress data internally
    * out-of-memory data storage and manipulation in R
- SCArray
    * applies GDS to single-cell data manipulation & analysis
    * utilizes DelayedArray & SingleCellExperiment in Bioconductor
    * reuse existing analysis packages efficiently (e.g., scater) via internal "seed-aware" functions


## Workflow & Data Structure

![](Fig_DataStruct.svg)


## Key Functions in SCArray

![](Fig_KeyFunction.svg)


## Example: Small-size Dataset

![](Fig_SmallDataset.svg)


## Example: Large-size Dataset (1.3M mouse brain cells)

![](Fig_LargeDataset.svg)


## Discussion

* SCArray
  - under development
  - GDS as a file-based representation
    - a DelayedArray backend
    - for large-scale single-cell data storage & manipulation
  - leverage existing analysis R packages (e.g., scater)
    - via DelayedMatrix
* Plans
  - further integrate with Bioconductor infrastructure
    - GDSArray, DelayedMatrixStats, ...
  - reimplement some memory-intensive algorithms


## Acknowledgements

* Genomics Research Center (GRC), AbbVie
  - Astrid Wachter
  - Priyanka Vijay
  - Yating(Claire) Chai
  - Zheng Zha

* Bioconductor
  - Qian Liu (Roswell Park Comprehensive Cancer Center)

* National Center for Supercomputing Applications (NCSA)
  - University of Illinois at Urbana-Champaign (UIUC)

---
title: "Large-scale single-cell omics data manipulation with GDS files"
author: "Dr. Xiuwen Zheng (Genomics Research Center, AbbVie)"
date: "Jan 2023"
output:
    html_document:
        theme: default
        highlight: tango
        toc: yes
vignette: >
    %\VignetteIndexEntry{Single-cell RNA-seq data manipulation using GDS files}
    %\VignetteKeywords{scRNAseq, GDS}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

```{r echo=FALSE}
options(width=110)
```

~

~

## Introduction

The SCArray package provides large-scale single-cell omics data manipulation
using Genomic Data Structure
([GDS](http://www.bioconductor.org/packages/gdsfmt)) files. It combines
dense/sparse matrices stored in GDS files and the Bioconductor infrastructure
framework
([SingleCellExperiment](http://www.bioconductor.org/packages/SingleCellExperiment)
and [DelayedArray](http://www.bioconductor.org/packages/DelayedArray)) to
provide out-of-memory data storage and manipulation using the R programming
language. As shown in the figure, SCArray provides a `SingleCellExperiment`
object for downstream data analyses. GDS is an alternative to HDF5.
Unlike HDF5, GDS supports the direct storage of a sparse matrix without
converting it to multiple vectors.

![**Figure 1**: Workflow of SCArray](scarray_fig.svg)

~

~

## Installation

* Requires R (>= v3.5.0),
[gdsfmt](http://www.bioconductor.org/packages/gdsfmt) (>= v1.35.4)

* Bioconductor repository

To install this package, start R and enter:
```{R, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("SCArray")
```

~

~

## Format conversion

### Conversion from SingleCellExperiment

The SCArray package can convert a single-cell experiment object
(SingleCellExperiment) to a GDS file using the function `scConvGDS()`.
For example,

```{r}
suppressPackageStartupMessages(library(SCArray))
suppressPackageStartupMessages(library(SingleCellExperiment))

# load a SingleCellExperiment object
fn <- system.file("extdata", "example.rds", package="SCArray")
sce <- readRDS(fn)

# convert to a GDS file
scConvGDS(sce, "test.gds")

# list data structure in the GDS file
(f <- scOpen("test.gds"))
scClose(f)
```

### Conversion from a matrix

The input of `scConvGDS()` can be a dense or sparse matrix for count data:

```{r}
library(Matrix)

cnt <- matrix(0, nrow=4, ncol=8)
set.seed(100); cnt[sample.int(length(cnt), 8)] <- rpois(8, 4)
(cnt <- as(cnt, "sparseMatrix"))

# convert to a GDS file
scConvGDS(cnt, "test.gds")
```

~

~

## Examples

When a single-cell GDS file is available, users can use `scExperiment()` to
load a SingleCellExperiment object from the GDS file. The assay data in the
SingleCellExperiment object are DelayedMatrix objects.

```{r}
# a GDS file in the SCArray package
(fn <- system.file("extdata", "example.gds", package="SCArray"))
# load a SingleCellExperiment object from the file
sce <- scExperiment(fn)
sce

# it is a DelayedMatrix (the whole matrix is not loaded)
assays(sce)$counts

# column data
colData(sce)
# row data
rowData(sce)
```

~

~

## Data Manipulation and Analysis

SCArray provides a `SingleCellExperiment` object for downstream data analyses.
At first, we create a log count matrix `logcnt` from the count matrix.
Note that `logcnt` is also a DelayedMatrix without actually generating the
whole matrix.
```{r}
cnt <- assays(sce)$counts
logcnt <- log2(cnt + 1)
logcnt
```
**Formally**, we call `logNormCounts()` in the scuttle package to normalize the raw counts.

```{r}
suppressPackageStartupMessages(library(scuttle))

sce <- logNormCounts(sce)
logcounts(sce)
```


### 1. Row and Column Summarization

The [DelayedMatrixStats](http://www.bioconductor.org/packages/DelayedMatrixStats) package provides summarization functions operating on rows and columns of DelayedMatrix objects. SCArray has provided the optimized implementations for the row and column summarization. For example, we can calculate the mean for each column or row of the log count matrix.

```{r}
col_mean <- colMeans(logcnt)
str(col_mean)
row_mean <- rowMeans(logcnt)
str(row_mean)

# calculate the mean and variance at the same time
mvar <- scRowMeanVar(logcnt)
head(mvar)
```

### 2. PCA analysis

The [scater](http://www.bioconductor.org/packages/scater) package can perform the Principal component analysis (PCA) on the normalized cell data.

```{r}
suppressPackageStartupMessages(library(scater))

# run umap analysis
sce <- runPCA(sce)
```
`scater::runPCA()` will call the function `beachmat::realizeFileBackedMatrix()` internally to realize a scaled and centered DelayedMatrix into its corresponding in-memory format, so it is memory-intensive for large-scale PCA.

**Instead**, the SCArray package provides `scRunPCA()` for reducing the memory usage in large-scale PCA by perform SVD on the relatively small covariance matrix.

```{r}
sce <- scRunPCA(sce)
```

`plotReducedDim()` plots cell-level reduced dimension results (PCA) stored
in the SingleCellExperiment object:

```{r fig.align="center",fig.width=4,fig.height=3}
plotReducedDim(sce, dimred="PCA")
```

### 3. UMAP analysis

The [scater](http://www.bioconductor.org/packages/scater) package can perform the uniform manifold approximation and projection (UMAP) for the cell data, based on the data in a SingleCellExperiment object.

```{r}
suppressPackageStartupMessages(library(scater))

# run umap analysis
sce <- runUMAP(sce)
```

`plotReducedDim()` plots cell-level reduced dimension results (UMAP) stored
in the SingleCellExperiment object:

```{r fig.align="center",fig.width=4,fig.height=3}
plotReducedDim(sce, dimred="UMAP")
```

~

~

## Miscellaneous

### Debugging

`options(SCArray.verbose=TRUE)` is used to enable displaying debug information when calling the functions in the SCArray packages. For example,

```{r}
options(SCArray.verbose=TRUE)

m <- rowMeans(logcnt)
str(m)
```

~

~

## Session Information

```{r}
# print version information about R, the OS and attached or loaded packages
sessionInfo()
```

```{r echo=FALSE}
unlink("test.gds", force=TRUE)
```

\name{row_nnzero}
\alias{row_nnzero}
\alias{row_nnzero,matrix-method}
\alias{row_nnzero,Matrix-method}
\alias{row_nnzero,DelayedMatrix-method}
\alias{row_nnzero,SC_GDSMatrix-method}
\alias{col_nnzero}
\alias{col_nnzero,matrix-method}
\alias{col_nnzero,Matrix-method}
\alias{col_nnzero,DelayedMatrix-method}
\alias{col_nnzero,SC_GDSMatrix-method}

\title{Numbers of Non-zeros}
\description{
    Calculates the numbers of non-zeros for each row or column of a matrix-like
object.
}

\usage{
row_nnzero(x, na.counted=NA, ...)
col_nnzero(x, na.counted=NA, ...)

\S4method{row_nnzero}{matrix}(x, na.counted=NA, ...)
\S4method{row_nnzero}{Matrix}(x, na.counted=NA, ...)
\S4method{row_nnzero}{DelayedMatrix}(x, na.counted=NA, ...)
\S4method{row_nnzero}{SC_GDSMatrix}(x, na.counted=NA, ...)

\S4method{col_nnzero}{matrix}(x, na.counted=NA, ...)
\S4method{col_nnzero}{Matrix}(x, na.counted=NA, ...)
\S4method{col_nnzero}{DelayedMatrix}(x, na.counted=NA, ...)
\S4method{col_nnzero}{SC_GDSMatrix}(x, na.counted=NA, ...)
}

\arguments{
    \item{x}{a matrix-like object}
    \item{na.counted}{a logical: TRUE for counting NA/NaN as non-zero, FALSE
        for counting NA/NaN as zero, NA (default) for return NA when
        encountering NA/NaN}
    \item{...}{additional arguments passed to specific methods}
}
\value{
    Return an integer vector object for the numbers of non-zeros.
}

\author{Xiuwen Zheng}

\examples{
# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

cnt <- scArray(fn, "counts")
cnt

row_nnzero(cnt, na.counted=TRUE)
col_nnzero(cnt, na.counted=TRUE)


rm(cnt)
}

\keyword{methods}
\keyword{GDS}

\name{scReplaceNA}
\alias{scReplaceNA}
\title{Replacement}
\description{
    Replace NA/NaN in a GDS-specific DelayedArray by a specified value.
}
\usage{
scReplaceNA(x, v=0L)
}
\arguments{
    \item{x}{a \code{SC_GDSArray} object}
    \item{v}{a length-one double or integer value}
}
\value{
    Return an object with the class \code{SC_GDSMatrix} or \code{SC_GDSArray}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scSetMin}}, \code{\link{scSetMax}}, \code{\link{scSetBounds}}
}

\examples{
suppressPackageStartupMessages(library(DelayedArray))

m <- matrix(1:12, nrow=3)
m[2, c(1,3)] <- NA
(mat <- DelayedArray(m))

new_m <-  scObj(mat)  # wrap a in-memory DelayedMatrix
class(new_m)  # SC_GDSMatrix

scReplaceNA(new_m,  999)
}

\keyword{GDS}

\name{SCArray-stats}
\alias{SCArray-stats}

\alias{rowSums}
\alias{rowSums,SC_GDSMatrix-method}
\alias{colSums}
\alias{colSums,SC_GDSMatrix-method}
\alias{rowSums2}
\alias{rowSums2,SC_GDSMatrix-method}
\alias{colSums2}
\alias{colSums2,SC_GDSMatrix-method}

\alias{rowLogSumExps}
\alias{rowLogSumExps,SC_GDSMatrix-method}
\alias{colLogSumExps}
\alias{colLogSumExps,SC_GDSMatrix-method}

\alias{rowProds}
\alias{rowProds,SC_GDSMatrix-method}
\alias{colProds}
\alias{colProds,SC_GDSMatrix-method}

\alias{rowMeans}
\alias{rowMeans,SC_GDSMatrix-method}
\alias{colMeans}
\alias{colMeans,SC_GDSMatrix-method}
\alias{rowMeans2}
\alias{rowMeans2,SC_GDSMatrix-method}
\alias{colMeans2}
\alias{colMeans2,SC_GDSMatrix-method}
\alias{rowWeightedMeans}
\alias{rowWeightedMeans,SC_GDSMatrix-method}
\alias{colWeightedMeans}
\alias{colWeightedMeans,SC_GDSMatrix-method}

\alias{rowVars}
\alias{rowVars,SC_GDSMatrix-method}
\alias{colVars}
\alias{colVars,SC_GDSMatrix-method}
\alias{rowWeightedVars}
\alias{rowWeightedVars,SC_GDSMatrix-method}
\alias{colWeightedVars}
\alias{colWeightedVars,SC_GDSMatrix-method}

\alias{rowSds}
\alias{rowSds,SC_GDSMatrix-method}
\alias{colSds}
\alias{colSds,SC_GDSMatrix-method}
\alias{rowWeightedSds}
\alias{rowWeightedSds,SC_GDSMatrix-method}
\alias{colWeightedSds}
\alias{colWeightedSds,SC_GDSMatrix-method}

\alias{rowMins}
\alias{rowMins,SC_GDSMatrix-method}
\alias{colMins}
\alias{colMins,SC_GDSMatrix-method}
\alias{rowMaxs}
\alias{rowMaxs,SC_GDSMatrix-method}
\alias{colMaxs}
\alias{colMaxs,SC_GDSMatrix-method}
\alias{rowRanges}
\alias{rowRanges,SC_GDSMatrix-method}
\alias{colRanges}
\alias{colRanges,SC_GDSMatrix-method}

\alias{scRowMeanVar}
\alias{scRowMeanVar,matrix-method}
\alias{scRowMeanVar,Matrix-method}
\alias{scRowMeanVar,SC_GDSMatrix-method}
\alias{scColMeanVar}
\alias{scColMeanVar,matrix-method}
\alias{scColMeanVar,Matrix-method}
\alias{scColMeanVar,SC_GDSMatrix-method}

\alias{rowsum}
\alias{rowsum,SC_GDSMatrix-method}
\alias{colsum}
\alias{colsum,SC_GDSMatrix-method}

\alias{rowAnyNAs}
\alias{rowAnyNAs,SC_GDSMatrix-method}
\alias{colAnyNAs}
\alias{colAnyNAs,SC_GDSMatrix-method}

\alias{rowCollapse}
\alias{rowCollapse,SC_GDSMatrix-method}
\alias{colCollapse}
\alias{colCollapse,SC_GDSMatrix-method}

\alias{rowDiffs}
\alias{rowDiffs,SC_GDSMatrix-method}
\alias{colDiffs}
\alias{colDiffs,SC_GDSMatrix-method}

\alias{rowSdDiffs}
\alias{rowSdDiffs,SC_GDSMatrix-method}
\alias{colSdDiffs}
\alias{colSdDiffs,SC_GDSMatrix-method}

\alias{rowVarDiffs}
\alias{rowVarDiffs,SC_GDSMatrix-method}
\alias{colVarDiffs}
\alias{colVarDiffs,SC_GDSMatrix-method}

\alias{rowAvgsPerColSet}
\alias{rowAvgsPerColSet,SC_GDSMatrix-method}
\alias{colAvgsPerRowSet}
\alias{colAvgsPerRowSet,SC_GDSMatrix-method}


\title{SC_GDSMatrix row/column summarization}
\description{
    The row/column summarization methods for the SC_GDSMatrix matrix,
extending the S4 methods in the \pkg{DelayedArray} and \pkg{DelayedMatrixStats}
packages.
}

\usage{
\S4method{rowSums}{SC_GDSMatrix}(x, na.rm=FALSE, dims=1)
\S4method{colSums}{SC_GDSMatrix}(x, na.rm=FALSE, dims=1)
\S4method{rowSums2}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{colSums2}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)

\S4method{rowLogSumExps}{SC_GDSMatrix}(lx, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{colLogSumExps}{SC_GDSMatrix}(lx, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)

\S4method{rowProds}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE,
    method=c("direct", "expSumLog"), ..., useNames=NA)
\S4method{colProds}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE,
    method=c("direct", "expSumLog"), ..., useNames=NA)

\S4method{rowMeans}{SC_GDSMatrix}(x, na.rm=FALSE, dims=1)
\S4method{colMeans}{SC_GDSMatrix}(x, na.rm=FALSE, dims=1)
\S4method{rowMeans2}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{colMeans2}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{rowWeightedMeans}{SC_GDSMatrix}(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{colWeightedMeans}{SC_GDSMatrix}(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)

\S4method{rowVars}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ..., useNames=NA)
\S4method{colVars}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ..., useNames=NA)
\S4method{rowWeightedVars}{SC_GDSMatrix}(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{colWeightedVars}{SC_GDSMatrix}(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)

\S4method{rowSds}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ..., useNames=NA)
\S4method{colSds}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE, center=NULL, ..., useNames=NA)
\S4method{rowWeightedSds}{SC_GDSMatrix}(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)
\S4method{colWeightedSds}{SC_GDSMatrix}(x, w=NULL, rows=NULL, cols=NULL, na.rm=FALSE, ..., useNames=NA)

\S4method{rowMins}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE)
\S4method{colMins}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE)
\S4method{rowMaxs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE)
\S4method{colMaxs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE)
\S4method{rowRanges}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE)
\S4method{colRanges}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE)

# Get means and variances together for each row or column,
#     return a matrix with two columns for mean and variance
scRowMeanVar(x, na.rm=FALSE, useNames=FALSE, ...)
scColMeanVar(x, na.rm=FALSE, useNames=FALSE, ...)
\S4method{scRowMeanVar}{SC_GDSMatrix}(x, na.rm=FALSE, useNames=FALSE, ...)
\S4method{scColMeanVar}{SC_GDSMatrix}(x, na.rm=FALSE, useNames=FALSE, ...)

# Compute column sums across rows
\S4method{rowsum}{SC_GDSMatrix}(x, group, reorder=TRUE, na.rm=FALSE, ...)
# Compute row sums across columns
\S4method{colsum}{SC_GDSMatrix}(x, group, reorder=TRUE, na.rm=FALSE, ...)

\S4method{rowAnyNAs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, ..., useNames=NA)
\S4method{colAnyNAs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, ..., useNames=NA)

\S4method{rowCollapse}{SC_GDSMatrix}(x, idxs, rows=NULL, ..., useNames=NA)
\S4method{colCollapse}{SC_GDSMatrix}(x, idxs, cols=NULL, ..., useNames=NA)

\S4method{rowDiffs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, lag=1L,
    differences=1L, ..., useNames=NA)
\S4method{colDiffs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, lag=1L,
    differences=1L, ..., useNames=NA)

\S4method{rowSdDiffs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE,
    diff=1L, trim=0, ..., useNames=NA)
\S4method{colSdDiffs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE,
    diff=1L, trim=0, ..., useNames=NA)

\S4method{rowVarDiffs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE,
    diff=1L, trim=0, ..., useNames=NA)
\S4method{colVarDiffs}{SC_GDSMatrix}(x, rows=NULL, cols=NULL, na.rm=FALSE,
    diff=1L, trim=0, ..., useNames=NA)

\S4method{rowAvgsPerColSet}{SC_GDSMatrix}(X, W=NULL, rows=NULL, S, FUN=rowMeans, ...,
    na.rm=NA, tFUN=FALSE)
\S4method{colAvgsPerRowSet}{SC_GDSMatrix}(X, W=NULL, cols=NULL, S, FUN=colMeans, ...,
    na.rm=NA, tFUN=FALSE)
}

\arguments{
    \item{x, lx, X}{A \link{SC_GDSMatrix} object (inherited from DelayedMatrix)}
    \item{dims}{not used, it should be 1}
    \item{rows, cols}{specify the subset of rows (and/or columns) to operate
        over; if \code{NULL}, no subsetting}
    \item{na.rm}{if \code{TRUE}, missing values (NaN and NA) will be removed}
    \item{w}{\code{NULL} or a numeric vector for weights}
    \item{W}{\code{NULL} or a matrix for weights}
    \item{center}{\code{NULL}, or a vector of pre-calculated row (column) means}
    \item{useNames}{if \code{TRUE}, the name attributes of result are set}
    \item{method}{"direct" (by default) or "expSumLog" (calculates the product
        via the logarithmic transform)}
    \item{group}{a vector for grouping the rows or columns}
    \item{reorder}{if \code{TRUE}, order the resulting matrix as
        \code{sort(unique(group))}; otherwise, it will be in the order that
        groups were encountered}
    \item{idxs}{An index vector specifying the columns (rows) to be extracted;
        the vector will be reused if the length is less than the number of
        columns or rows}
    \item{lag}{the lag, an integer}
    \item{differences, diff}{the order of difference, an integer}
    \item{trim}{fraction of observations to be trimmed}
    \item{S}{an integer matrix specifying the subsets, see
        \link[MatrixGenerics]{rowAvgsPerColSet}}
    \item{FUN}{summary statistic function, see
        \link[MatrixGenerics]{rowAvgsPerColSet}}
    \item{tFUN}{If \code{TRUE}, \code{X} is transposed before it is passed to
        \code{FUN}, see \link[MatrixGenerics]{rowAvgsPerColSet}}
    \item{...}{additional arguments passed to specific methods: \code{BPPARAM}
        can be specified (if not specified, \code{getAutoBPPARAM()} is used
        instead)}
}

\details{
    All these operations are block-processed according to the data stored in
the GDS file.
}

\author{Xiuwen Zheng}
\seealso{
    \itemize{
        \item The \pkg{DelayedMatrixStats} package for more row/column
            summarization methods for \link{DelayedMatrix} objects.
        \item \link{DelayedArray-utils} for other common operations on
            \link{DelayedMatrix} objects.
        \item \link{DelayedMatrix} objects.
        \item \link[base]{matrix} objects in base R.
        \item \link{getAutoBPPARAM}, \link{BiocParallelParam} for parallel
            processing,
        \item The \pkg{MatrixGenerics} package for more row/column
            summarization methods.
    }
}

\keyword{methods}
\keyword{GDS}

\name{SCArray-utils}
\alias{SCArray-utils}

\alias{[}
\alias{[,SC_GDSArray-method}
\alias{[,SC_GDSArray,ANY,ANY,ANY-method}
\alias{[[}
\alias{[[,SC_GDSArray-method}
\alias{[[,SC_GDSArray,ANY,ANY-method}
\alias{Ops}
\alias{Ops,SC_GDSArray-method}
\alias{Math}
\alias{Math,SC_GDSArray-method}
\alias{+}
\alias{+,SC_GDSArray,missing-method}
\alias{-}
\alias{-,SC_GDSArray,missing-method}
\alias{names<-}
\alias{names<-,SC_GDSArray-method}
\alias{dimnames<-}
\alias{dimnames<-,SC_GDSArray,ANY-method}

\alias{\%*\%}
\alias{\%*\%,SC_GDSMatrix,ANY-method}
\alias{\%*\%,ANY,SC_GDSMatrix-method}
\alias{crossprod}
\alias{crossprod,ANY,SC_GDSMatrix-method}
\alias{crossprod,SC_GDSMatrix,ANY-method}
\alias{crossprod,SC_GDSMatrix,missing-method}
\alias{tcrossprod}
\alias{tcrossprod,ANY,SC_GDSMatrix-method}
\alias{tcrossprod,SC_GDSMatrix,ANY-method}
\alias{tcrossprod,SC_GDSMatrix,missing-method}

\alias{scale}
\alias{scale,SC_GDSMatrix-method}
\alias{pmin2}
\alias{pmin2,SC_GDSArray,SC_GDSArray-method}
\alias{pmin2,SC_GDSArray,vector-method}
\alias{pmin2,vector,SC_GDSArray-method}
\alias{pmax2}
\alias{pmax2,SC_GDSArray,SC_GDSArray-method}
\alias{pmax2,SC_GDSArray,vector-method}
\alias{pmax2,vector,SC_GDSArray-method}

\title{SC_GDSArray subsetting, Ops, Math}
\description{
    Subsetting, Arith, Compare, Logic and Math operations on the SC_GDSArray
object.
}

\usage{
# x[i, j, ... , drop = TRUE]
\S4method{[}{SC_GDSArray}(i, j, ... , drop=TRUE)
# x[[i, j, ...]]
\S4method{[[}{SC_GDSArray}(i, j, ...)

\S4method{Ops}{SC_GDSArray}(e1, e2)
\S4method{Math}{SC_GDSArray}(x)

# names(x) <- value
# dimnames(x) <- value

# Centers and/or scales the columns of a matrix
\S4method{scale}{SC_GDSMatrix}(x, center=TRUE, scale=TRUE)

\S4method{pmin2}{SC_GDSArray,SC_GDSArray}(e1, e2)
\S4method{pmin2}{SC_GDSArray,vector}(e1, e2)
\S4method{pmin2}{vector,SC_GDSArray}(e1, e2)
\S4method{pmax2}{SC_GDSArray,SC_GDSArray}(e1, e2)
\S4method{pmax2}{SC_GDSArray,vector}(e1, e2)
\S4method{pmax2}{vector,SC_GDSArray}(e1, e2)
}

\arguments{
    \item{x}{A \link{SC_GDSArray} or \link{SC_GDSMatrix} object}
    \item{i, j, ...}{indices specifying elements to extract}
    \item{drop}{if \code{TRUE} the result will be coerced to the lowest
        possible dimension}
    \item{e1, e2}{objects}
    \item{value}{\code{NULL}, a character vector for \code{names<-} or a list
        of character vectors for \code{dimnames<-}}
    \item{center}{either a logical value or a numeric vector (e.g., \code{FALSE}
        or \code{0} for no centering)}
    \item{scale}{either a logical value or a numeric vector (e.g., \code{TRUE}
        or \code{1} for no scaling)}
}
\value{
    All these operations return a SC_GDSArray or SC_GDSMatrix object.
}

\details{
    All these operations return a SC_GDSArray or SC_GDSMatrix object.
    \describe{
        \item{\code{Arith}:}{
            \code{"+"}, \code{"-"}, \code{"*"}, \code{"^"}, \code{"\%\%"},
            \code{"\%/\%"}, \code{"/"}}
        \item{\code{Compare}:}{
            \code{"=="}, \code{">"}, \code{"<"}, \code{"!="}, \code{"<="},
            \code{">="}}
        \item{\code{Logic}:}{
            \code{"&"}, \code{"|"}.}
        \item{\code{Ops}:}{
            \code{"Arith"}, \code{"Compare"}, \code{"Logic"}}
        \item{\code{Math}:}{
            \code{"abs"}, \code{"sign"}, \code{"sqrt"}, \code{"ceiling"},
            \code{"floor"}, \code{"trunc"}, \code{"cummax"}, \code{"cummin"},
            \code{"cumprod"}, \code{"cumsum"}, \code{"log"}, \code{"log10"},
            \code{"log2"}, \code{"log1p"}, \code{"acos"}, \code{"acosh"},
            \code{"asin"}, \code{"asinh"}, \code{"atan"}, \code{"atanh"},
            \code{"exp"}, \code{"expm1"},
            \code{"cos"}, \code{"cosh"}, \code{"cospi"},
            \code{"sin"}, \code{"sinh"}, \code{"sinpi"},
            \code{"tan"}, \code{"tanh"}, \code{"tanpi"},
            \code{"gamma"}, \code{"lgamma"}, \code{"digamma"},
            \code{"trigamma"}
        }
    }
}

\author{Xiuwen Zheng}
\seealso{
    \link{Ops}, \link{Math}, \link{SCArray-stats}
}

\examples{
fn <- system.file("extdata", "example.gds", package="SCArray")

x <- scArray(fn, "counts")

x[1:8, 1:32]
x > 0
pmin2(x, 1)
log1p(x)
scale(x)

rm(x)
}

\keyword{methods}
\keyword{GDS}

\name{scOpen}
\alias{scOpen}
\alias{scClose}
\title{Open/Close a Single-cell GDS File}
\description{
    Opens or closes a single-cell GDS file.
}
\usage{
scOpen(gdsfn, readonly=TRUE, allow.duplicate=TRUE)
scClose(gdsfile)
}
\arguments{
    \item{gdsfn}{the input file name}
    \item{readonly}{whether read-only or not}
    \item{allow.duplicate}{if \code{TRUE}, it is allowed to open a GDS file
        with read-only mode when it has been opened in the same R session}
    \item{gdsfile}{a single-cell GDS object with class \code{SCArrayFileClass}}
}
\value{
    Return an object of class \code{SCArrayFileClass} inherited from
\code{\link{gds.class}}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scArray}}
}

\examples{
# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

# open the GDS file
(f <- scOpen(fn))

# read a GDS file
cell.id <- read.gdsn(index.gdsn(f, "feature.id"))
samp.id <- read.gdsn(index.gdsn(f, "sample.id"))

# get a DelayedArray object
(cnt <- scArray(f, "counts"))

scClose(f)
}

\keyword{GDS}
\keyword{SingleCell}

\name{scHDF2GDS}
\alias{scHDF2GDS}
\title{Convert HDF5 files to GDS}
\description{
    Creates a single-cell GDS file from Cell Ranger HDF5 files.
}
\usage{
scHDF2GDS(h5_fn, outfn, group=c("matrix", "mm10"), feature_path=character(),
    type=c("float32", "float64", "int32"), compress="LZMA_RA", clean=TRUE,
    verbose=TRUE)
}
\arguments{
    \item{h5_fn}{the input HDF5 file name}
    \item{outfn}{the output file name in GDS format}
    \item{group}{the name of the group in the HDF5 file where the sparse
        matrix is stored; if there are more than one group names, the first
        existing group in the HDF5 file is used; \code{"mm10"} is usually
        used for 10x Genomics datasets}
    \item{feature_path}{a character vector for feature variables, otherwise
        detecting automatically using "genes", "gene_names" and "features/*"
        when available}
    \item{type}{numeric data type in the output file}
    \item{compress}{the compression method, see \code{\link{add.gdsn}}}
    \item{clean}{TRUE}
    \item{verbose}{if \code{TRUE}, show information}
}
\details{
    The packages \pkg{rhdf5} and \pkg{HDF5Array} should be installed.
}
\value{
    Return the path of the output file.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scConvGDS}}, \code{\link{scMEX2GDS}}
}

\keyword{CellRanger}
\keyword{GDS}
\keyword{SingleCell}

\name{scMEX2GDS}
\alias{scMEX2GDS}
\title{Convert MEX files to GDS}
\description{
    Creates a single-cell GDS file from Cell Ranger MEX files.
}
\usage{
scMEX2GDS(feature_fn, barcode_fn, mtx_fn, outfn,
    feature_colnm=c("id", "gene", "feature_type"),
    type=c("float32", "float64", "int32"), compress="LZMA_RA", clean=TRUE,
    verbose=TRUE)
}
\arguments{
    \item{feature_fn}{the input file name for features}
    \item{barcode_fn}{the input file name for barcodes}
    \item{mtx_fn}{the input count matrix in MEX format}
    \item{outfn}{the output file name in GDS format}
    \item{feature_colnm}{the column names used in \code{feature_fn}}
    \item{type}{numeric data type in the output file}
    \item{compress}{the compression method, see \code{\link{add.gdsn}}}
    \item{clean}{TRUE}
    \item{verbose}{if \code{TRUE}, show information}
}
\value{
    Return the path of the output file.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scConvGDS}}, \code{\link{scHDF2GDS}}
}

\keyword{CellRanger}
\keyword{GDS}
\keyword{SingleCell}

\name{SCArray-classes}
\alias{SCArray-classes}
\alias{SCArrayFileClass}
\alias{SCArrayFileClass-class}
\alias{SC_GDSArray}
\alias{SC_GDSArray-class}
\alias{SC_GDSMatrix}
\alias{SC_GDSMatrix-class}

\docType{class}
\title{Class list defined in SCArray}
\description{
    \code{SCArrayFileClass} is a class directly inheriting from
\code{gds.class}. \code{SC_GDSArray} is a DelayedArray with a
\code{SCArraySeed}. \code{SC_GDSMatrix} is 2-dim \code{SC_GDSArray}.

    The package combines dense/sparse matrices stored in GDS files and the
Bioconductor infrastructure framework to provide out-of-memory data storage
and manipulation using the R programming language.
}
\author{
    Xiuwen Zheng \email{xiuwen.zheng@abbvie.com}
}

\keyword{GDS}
\keyword{SingleCell}

\name{scArray}
\alias{scArray}
\title{Get an DelayedArray instance}
\description{
    Gets an DelayedArray instance from a single-cell omics GDS file.
}
\usage{
scArray(gdsfile, varname)
}
\arguments{
    \item{gdsfile}{character for a file name, or a single-cell GDS object with
        class \code{SCArrayFileClass}}
    \item{varname}{character for the node name in the GDS file}
}
\value{
    Return an object of class \code{\link{DelayedArray}}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scOpen}}, \code{\link{scExperiment}}
}

\examples{
# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

cnt <- scArray(fn, "counts")
cnt

rm(cnt)
}

\keyword{GDS}
\keyword{SingleCell}

\name{scNumSplit}
\alias{scNumSplit}
\title{Split a number}
\description{
    Splits a number into multiple groups with equal size.
}
\usage{
scNumSplit(num, BPPARAM=getAutoBPPARAM())
}
\arguments{
    \item{num}{a length-one number (the total count) for splitting
        (must be >= 0)}
    \item{BPPARAM}{NULL, a number for the number of groups, or a
        \code{BiocParallelParam} object; if not specified, call
        \code{getAutoBPPARAM()}}
}
\value{
    Return a list of length-two numeric vectors for the start and end
positions. \code{BPPARAM=NULL} is as the same as \code{BPPARAM=1}, if it is a
\code{BiocParallelParam} object, call \code{bpnworkers()} to get the number of
groups.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{getAutoBPPARAM}}, \code{\link{BiocParallelParam}},
    \code{\link{bpnworkers}}
}

\examples{
scNumSplit(100, NULL)
scNumSplit(100, 0)
scNumSplit(100, 1)
scNumSplit(100, 3)
scNumSplit(100)

scNumSplit(0)  # zero-length
}

\keyword{GDS}

\name{SCArray-package}
\alias{SCArray-package}
\alias{SCArray}
\docType{package}
\title{Large-scale single-cell omics data manipulation with GDS files}
\description{
    The package combines dense/sparse matrices stored in GDS files and the
Bioconductor infrastructure framework to provide out-of-memory data storage
and manipulation using the R programming language.
}
\details{
    \tabular{ll}{
        Package: \tab SCArray \cr
        Type: \tab Package \cr
        License: \tab GPL version 3 \cr
    }
}
\author{
    Xiuwen Zheng \email{xiuwen.zheng@abbvie.com}
}

\examples{
# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

sce <- scExperiment(fn)
sce

rm(sce)
}

\keyword{GDS}
\keyword{SingleCell}

\name{scSetBounds}
\alias{scSetBounds}
\alias{scSetMax}
\alias{scSetMin}
\title{Set the bounds}
\description{
    Set the maximum and/or minimum on a GDS-specific DelayedArray.
}
\usage{
scSetMax(x, vmax)
scSetMin(x, vmin)
scSetBounds(x, vmin=NaN, vmax=NaN)
}
\arguments{
    \item{x}{a \code{SC_GDSArray} object}
    \item{vmax}{maximum, length-one}
    \item{vmin}{minimum, length-one}
}
\value{
    Return an object with the class \code{SC_GDSMatrix} or \code{SC_GDSArray}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scReplaceNA}}
}

\examples{
suppressPackageStartupMessages(library(DelayedArray))

m <- matrix(1:12, nrow=3)
(mat <- DelayedArray(m))

new_m <-  scObj(mat)  # wrap a in-memory DelayedMatrix
class(new_m)  # SC_GDSMatrix

scSetMax(new_m, 5)
scSetMin(new_m, 5)
scSetBounds(new_m, 4, 9)
}

\keyword{GDS}

\name{scExperiment}
\alias{scExperiment}
\title{Get a SummarizedExperiment}
\description{
    Gets an instance of SingleCellExperiment or SummarizedExperiment.
}
\usage{
scExperiment(gdsfile, sce=TRUE, use.names=TRUE, load.row=TRUE, load.col=TRUE)
}
\arguments{
    \item{gdsfile}{character for a file name, or a single-cell GDS object with
        class \code{SCArrayFileClass}}
    \item{sce}{if \code{TRUE}, return an instance of
        \code{SingleCellExperiment}, otherwise an instance of
        \code{SummarizedExperiment}}
    \item{use.names}{if \code{TRUE}, load \code{dimnames} from 'feature.id' and
        'sample.id'}
    \item{load.row}{\code{TRUE} for loading \code{rowData} from the gds node
        "feature.data" in \code{gdsfile}}
    \item{load.col}{\code{TRUE} for loading \code{colData} from the gds node
        "sample.data" in \code{gdsfile}}
}
\value{
    Return an instance of \code{\link{SingleCellExperiment}} or
\code{\link{SummarizedExperiment}}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scOpen}}, \code{\link{scClose}}
}

\examples{
# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

sce <- scExperiment(fn)
sce

remove(sce)
}

\keyword{GDS}
\keyword{SingleCell}

\name{scRowAutoGrid}
\alias{scRowAutoGrid}
\alias{scColAutoGrid}
\title{Automatic grids for matrix-like objects}
\description{
    Create automatic grids (RegularArrayGrid or ArbitraryArrayGrid for sparse
matrices) to use for block processing of matrix-like objects, where the blocks
are made of full rows or full columns.
}
\usage{
scRowAutoGrid(x, force=FALSE, nnzero=NULL)
scColAutoGrid(x, force=FALSE, nnzero=NULL)
}
\arguments{
    \item{x}{a matrix-like object (e.g., a SC_GDSMatrix object)}
    \item{force}{a logical, only applicable when \code{x} is a sparse in-memory
        matrix or a sparse \code{SC_GDSMatrix} object, see details}
    \item{nnzero}{a numeric vector for the numbers of non-zeros for rows or
        columns, \code{NULL} (default) for calling \code{row_nnzero()}
        or \code{col_nnzero()} when needed}
}
\details{
    The functions return regular RegularArrayGrid (calling \code{rowAutoGrid()}
or \code{colAutoGrid}), when \code{x} is neither a sparse in-memory matrix nor
a sparse \code{SC_GDSMatrix} object; otherwise, make use of the information of
the numbers of non-zeros to create ArbitraryArrayGrid for more efficient grids.
    When \code{force} is applicable and \code{force=TRUE}, the functions
return \code{ArbitraryArrayGrid} which needs the \code{nnzero} values. For
\code{force=FALSE}, \code{scRowAutoGrid()} returns \code{ArbitraryArrayGrid}
when \code{x} is not transposed, and \code{scColAutoGrid()} returns
\code{ArbitraryArrayGrid} when \code{x} is transposed.
    If \code{nnzero=NULL} and it is needed, the numbers of non-zeros for rows
or columns will be calculated internally. For a large matrix, it is more
efficient when \code{nnzero} is pre-defined.
    The internal block size can be controlled by \code{setAutoBlockSize()}.
    If the number of blocks in \code{ArbitraryArrayGrid} is more than
\code{RegularArrayGrid}, the functions return \code{RegularArrayGrid} instead
when \code{force} is not \code{TRUE}.

    Usually, \code{gd <- scRowAutoGrid()} or \code{gd <- scColAutoGrid()} is
used together with \code{blockApply(, grid=gd, as.sparse=attr(gd, "as.sparse"))}
or \code{blockReduce(, grid=gd, as.sparse=attr(gd, "as.sparse"))} to take
advantage of sparse matrices.
}
\value{
    Return an object of \code{RegularArrayGrid} or \code{ArbitraryArrayGrid}.
\code{attr(, "as.sparse")} is a suggested logical value for \code{as.sparse}
in \code{blockApply()} or \code{blockReduce()}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{rowAutoGrid}}, \code{\link{colAutoGrid}},
    \code{\link{setAutoBlockSize}},
    \code{\link{blockApply}}, \code{\link{blockReduce}}
}

\examples{
# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

cnt <- scArray(fn, "counts")
cnt

setAutoBlockSize(1048576)  # use 1MB

scRowAutoGrid(cnt)  # it returns RegularArrayGrid since cnt is not very sparse
rowAutoGrid(cnt)
scRowAutoGrid(cnt, force=TRUE)  # ArbitraryArrayGrid


library(Matrix)
cnt2 <- Diagonal(1e5)  # a very sparse matrix

scRowAutoGrid(cnt2)    # 5 blocks
length(rowAutoGrid(cnt2))    # 100000

scColAutoGrid(cnt2)          # 5 blocks
length(colAutoGrid(cnt2))    # 100000 blocks


setAutoBlockSize()  # reset

rm(cnt)
}

\keyword{GDS}

\name{scGetFiles}
\alias{scGetFiles}
\alias{scGetFiles,SC_GDSArray-method}
\alias{scGetFiles,SummarizedExperiment-method}

\title{File names for on-disk backend}
\description{
    Get a list of file names for DelayedArray with an on-disk backend.
}

\usage{
scGetFiles(object, ...)
\S4method{scGetFiles}{SC_GDSArray}(object, ...)
\S4method{scGetFiles}{SummarizedExperiment}(object, ...)
}

\arguments{
    \item{object}{input R object (e.g., a GDS-specific DelayedArray)}
    \item{...}{additional arguments passed to specific methods}
}
\value{
    Return a character vector storing file names.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{path}}
}

\keyword{methods}
\keyword{GDS}

\name{scRunPCA}
\alias{scRunPCA}
\alias{runPCA}
\alias{runPCA,SC_GDSMatrix-method}
\title{Perform PCA on SC_GDSMatrix and expression data}
\description{
    Perform a Principal Components Analysis (PCA) on cells in the
SingleCellExperiment object.
}
\usage{
scRunPCA(sce, ncomponents=50, ntop=500, subset_row=NULL, scale=FALSE,
    altexp=NULL, name="PCA", exprs_values="logcounts", dimred=NULL,
    n_dimred=NULL, BSPARAM=NULL, BPPARAM=SerialParam(), verbose=TRUE)

\S4method{runPCA}{SC_GDSMatrix}(x, rank, center=TRUE, scale=FALSE, get.rotation=TRUE,
    get.pcs=TRUE, ...)
}
\arguments{
    \item{sce}{a SingleCellExperiment or SummarizedExperiment object}
    \item{x}{a SC_GDSMatrix object}
    \item{ncomponents, rank}{# of calculated principal components}
    \item{ntop}{# of features with the highest variances to use for PCA}
    \item{subset_row}{specifying the subset of features to use}
    \item{center}{if \code{TRUE}, expression values will be be centered}
    \item{scale}{if \code{TRUE}, expression values will be be standardized}
    \item{altexp}{String or integer scalar specifying an alternative experiment
        containing the input data}
    \item{name}{the name to be used to store the result in \code{reducedDims}}
    \item{exprs_values}{the assay name containing the expression values}
    \item{dimred}{String or integer scalar specifying the existing
        dimensionality reduction results to use}
    \item{n_dimred}{Integer scalar or vector specifying the dimensions to use
        if \code{dimred} is specified}
    \item{BSPARAM}{A BiocSingularParam object specifying which algorithm to be
        used in \code{runPCA} in the BiocSingular package}
    \item{BPPARAM}{A BiocParallelParam object for parallelized calculation}
    \item{get.rotation}{if \code{TRUE}, return rotation vectors}
    \item{get.pcs}{if \code{TRUE}, return principal component scores}
    \item{verbose}{if TRUE, show information}
    \item{...}{For \code{runPCA}, this contains further arguments to pass
          to \code{runSVD}, including \code{BSPARAM} to specify the algorithm
          that should be used, and \code{BPPARAM} to control parallelization.}
}
\details{
    The function \code{runPCA()} simply calls \code{\link{runSVD}} and converts
the results into a format similar to that returned by \code{\link{prcomp}}.

\code{BSPARAM} can be one of
\describe{
    \item{\code{ExactParam()}:}{exact SVD with \code{\link{runExactSVD}}.}
    \item{\code{IrlbaParam()}:}{approximate SVD with \pkg{irlba} via
        \code{\link{runIrlbaSVD}}.}
    \item{\code{RandomParam()}:}{approximate SVD with \pkg{rsvd} via
        \code{\link{runRandomSVD}}.}
    \item{\code{FastAutoParam()}:}{fast approximate SVD, chosen based on
        the matrix representation.}
}
\code{fold=1} in BiocSingularParam is used for the situation that the
covariance matrix is relatively small, and running SVD on the small covariance
matrix can be more effecient. When \code{fold=Inf}, running SVD on the matrix
directly and will read the matrix multiple times. If it is a file-based matrix,
\code{fold=Inf} could be slow.
}
\value{
    Returns a SingleCellExperiment object containing the PC coordinate matrix
in \code{reducedDims(..., name)}. The attributes of the PC coordinate matrix
have "percentVar", "varExplained" and "rotation" (see \code{scater::runPCA}
for more details).
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{runSVD}} for the underlying SVD function.

    \code{?\linkS4class{BiocSingularParam}} for the SVD algorithm choices.

    \code{\link[BiocSingular]{runPCA}}.
}

\examples{
library(BiocSingular)

# a GDS file for SingleCellExperiment
fn <- system.file("extdata", "example.gds", package="SCArray")

x <- scArray(fn, "counts")
x <- x[1:200, ]
x

pc <- runPCA(x, BSPARAM=ExactParam(fold=1))  # using covariance matrix
str(pc)

rm(x)
}

\keyword{PCA}
\keyword{GDS}
\keyword{SingleCell}

\name{scMemory}
\alias{scMemory}
\alias{scMemory,DelayedArray-method}
\alias{scMemory,SummarizedExperiment-method}

\title{Load Data to Memory}
\description{
    Loads the internal data to memory for any on-disk object.
}

\usage{
scMemory(x, ...)
\S4method{scMemory}{DelayedArray}(x, ...)
\S4method{scMemory}{SummarizedExperiment}(x, ...)
}

\arguments{
    \item{x}{input R object (e.g., a DelayedArray)}
    \item{...}{additional arguments passed to specific methods}
}
\value{
    Return an object (it maybe a different type compared with \code{x}).
}

\author{Xiuwen Zheng}

\examples{
suppressPackageStartupMessages(library(DelayedArray))

m <- matrix(1:12, nrow=3)
(mat <- DelayedArray(m))

str(scMemory(mat))
}

\keyword{methods}
\keyword{GDS}

\name{scObj}
\alias{scObj}
\title{DelayedArray Object in GDS}
\description{
    Convert to SC_GDSArray/SC_GDSMatrix for utilizing GDS specific functions.
}
\usage{
scObj(obj, verbose=FALSE)
}
\arguments{
    \item{obj}{a SummarizedExperiment, SingleCellExperiment or DelayedArray
        object}
    \item{verbose}{if \code{TRUE}, show information}
}
\value{
    Return the object \code{obj} with the object class \code{DelayedArray}
replaced by the class \code{SC_GDSMatrix} or \code{SC_GDSArray}.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scArray}}, \code{\link{scExperiment}}
}

\keyword{GDS}
\keyword{SingleCell}

\name{scConvGDS}
\alias{scConvGDS}
\title{Create a GDS file}
\description{
    Creates a single-cell GDS file from an R object.
}
\usage{
scConvGDS(obj, outfn, assay.name=NULL, save.sp=TRUE,
    type=c("float32", "float64", "int32"), compress="LZMA_RA", clean=TRUE, verbose=TRUE)
}
\arguments{
    \item{obj}{a dense/sparse matrix, DelayedMatrix, SummarizedExperiment or
        SingleCellExperiment}
    \item{outfn}{the output file name in GDS format}
    \item{assay.name}{a character vector for assay names or \code{NULL}; if \code{NULL},
        to include all available assays, otherwise only include the assays in
        \code{assay.name}}
    \item{save.sp}{if \code{TRUE}, save it to a sparse matrix in GDS; otherwise,
        store dense matrix}
    \item{type}{numeric data type in the output file}
    \item{compress}{the compression method, see \code{\link{add.gdsn}}; or
        \code{""} for no data compression}
    \item{clean}{TRUE}
    \item{verbose}{if \code{TRUE}, show information}
}
\value{
    Return the path of the output file.
}

\author{Xiuwen Zheng}
\seealso{
    \code{\link{scOpen}}, \code{\link{scClose}},
    \code{\link{scMEX2GDS}}, \code{\link{scHDF2GDS}}
}

\examples{
# load a SingleCellExperiment object
fn <- system.file("extdata", "example.rds", package="SCArray")
sce <- readRDS(fn)
sce

scConvGDS(sce, "test.gds")

# remove the temporary file
unlink("test.gds")
}

\keyword{GDS}
\keyword{SingleCell}
